#include "ezwin.h"
#include<cassert>
#define pi 3.14159265

SimpleWindow CS("Carrom Board", 20.0,25.0,Position(1.0,1.0));
float xm,ym,sx,sy,x,y,b,z;
int l=0;
void Board();
int Move(const Position &P)
{
	xm=P.GetXDistance();
	ym=P.GetYDistance();
	sy=2.25;


	if(xm>23.0 && xm<27.0 && ym>16.5 && ym<18.0)
	{
		CS.Message("Thanks for Playing");
		CS.Close();
	}


	if(l==0)
	{
		if(xm>3.75 && xm<16.25)	// x & y both inside the strip
		{
			sx=P.GetXDistance();
		}
	
		else if(xm<=3.75)	//x left of the strip
		{
			sx=3.0;
		}

		else if(xm>=16.25 && !(xm>23.0 && xm<27.0 && ym>1.5 && ym<3.0))	//x right of the strip
		{
			sx=17.0;
		}

		else if(xm>23.0 && xm<27.0 && ym>1.5 && ym<3.0)
			l=1;

		Board();
		
		return 1;	
	}
	
	if(l==1 && ym>sy)
	{
		b=atan((ym-sy)/(xm-sx));
		z=0.35;
		if(xm!=sx)
		{
			if((ym-sy)*(xm-sx)<0)	b = atan((ym-sy)/(xm-sx)) + pi;
			else	b = atan((ym-sy)/(xm-sx));
			for(x=sx ; z>=0 ; x+=z*cos(b),z-=0.005)
			{	
				y = tan(b) * (x-sx) + sy;
				CS.RenderEllipse(Position(x-0.5,y-0.5), Position(x+0.5,y+0.5), Cyan, true);
				CS.RenderEllipse(Position(x-0.3,y-0.3), Position(x+0.3,y+0.3), White, false);
				CS.RenderEllipse(Position(x-0.1,y-0.1), Position(x+0.1,y+0.1), Green, true);
				for(int j=0;j<3500000;j++);
			}
		}
		else
		{
			for(y=sy ; z>=0 ; y+=z*cos(b),z-=0.005)
			{
				CS.RenderEllipse(Position(sx-0.5,y-0.5), Position(sx+0.5,y+0.5), Cyan, true);
				CS.RenderEllipse(Position(sx-0.3,y-0.3), Position(sx+0.3,y+0.3), White, false);
				CS.RenderEllipse(Position(sx-0.1,y-0.1), Position(sx+0.1,y+0.1), Green, true);
				for(int j=0;j<15000000;j++);
			}	
		}	
	}
	Board();
	return 1;
}

int ApiMain()
{	
	CS.Open();
	sx=10.0;	sy=2.25;	

	Board();
	CS.SetMouseClickCallback(Move);

	return 0;
}

void Board()
{
	CS.RenderRectangle(Position(0.0,0.0), Position(30.0,30.0), White, false);
	
	CS.RenderRectangle(Position(3.0,2.0), Position(17.0,2.5), White, true);	//Top
	CS.RenderRectangle(Position(2.0,3.0), Position(2.5,17.0), White, true);	//left
	CS.RenderRectangle(Position(3.0,17.5), Position(17.0,18.0), White, true);	//Bottom
	CS.RenderRectangle(Position(17.5,3.0), Position(18.0,17.0), White, true);	//Right
	CS.RenderEllipse(Position(8.0,8.0), Position(12.0,12.0), White, true);	//Center Circle
	CS.RenderEllipse(Position(8.5,8.5), Position(11.5,11.5), Green, true);	//Center Circle
	CS.RenderEllipse(Position(9.7,9.7), Position(10.3,10.3), Red, true);	//Center Circle
//Holes	
	CS.RenderEllipse(Position(-1.0,-1.0), Position(1.0,1.0), Black, true);	//Top left
	CS.RenderEllipse(Position(-1.0,19.0), Position(1.0,21.0), Black, true);	//Bottom left
	CS.RenderEllipse(Position(19.0,19.0), Position(21.0,21.0), Black, true);	//Bottom right
	CS.RenderEllipse(Position(19.0,-1.0), Position(21.0,1.0), Black, true);	//Top right

//Red Circles
	CS.RenderEllipse(Position(2.75,2.0), Position(3.25,2.5), Red, true);
	CS.RenderEllipse(Position(16.75,2.0), Position(17.25,2.5), Red, true);
	
	CS.RenderEllipse(Position(2.0,2.75), Position(2.5,3.25), Red, true);
	CS.RenderEllipse(Position(2.0,16.75), Position(2.5,17.25), Red, true);		

	CS.RenderEllipse(Position(2.75,17.5), Position(3.25,18.0), Red, true);	
	CS.RenderEllipse(Position(16.75,17.5), Position(17.25,18.0), Red, true);	
	
	CS.RenderEllipse(Position(17.5,2.75), Position(18.0,3.25), Red, true);
	CS.RenderEllipse(Position(17.5,16.75), Position(18.0,17.25), Red, true);
//Arrows
	CS.RenderLine(Position(1.0,1.0), Position(4.0,4.0), Black,0.05);
        CS.RenderLine(Position(16.0,4.0),Position(19.0,1.0),Black,0.05);
        CS.RenderLine(Position(1.0,19.0), Position(4.0,16.0), Black,0.05);
        CS.RenderLine(Position(16.0,16.0), Position(19.0,19.0), Black,0.05);

//Fix Striker
	CS.RenderRectangle(Position(23.0,1.5), Position(27.0,3.0), Black, true);
	CS.RenderRectangle(Position(23.1,1.6), Position(26.9,2.9), Black, false);
	CS.RenderRectangle(Position(23.2,1.7), Position(26.8,2.8), White, true);
	CS.RenderText(Position(23.0,1.5), Position(27.0,3.0),"Fix Striker", Red);
//Quit
	CS.RenderRectangle(Position(23.0,16.5), Position(27.0,18.0), Black, true);
	CS.RenderRectangle(Position(23.1,16.6), Position(26.9,17.9), Black, false);
	CS.RenderRectangle(Position(23.2,16.7), Position(26.8,17.8), White, true);
	CS.RenderText(Position(23.0,16.5), Position(27.0,18.0),"Quit", Red);

	CS.RenderEllipse(Position(sx-0.5,sy-0.5), Position(sx+0.5,sy+0.5), Cyan, true);
	CS.RenderEllipse(Position(sx-0.3,sy-0.3), Position(sx+0.3,sy+0.3), White, false);
	CS.RenderEllipse(Position(sx-0.1,sy-0.1), Position(sx+0.1,sy+0.1), Green, true);	

}
