#include<iostream>
#include<cassert>
#include"ezwin.h"
#include"rect.h"
#include"circle.h"
#include"shape.h"
#include"position.h"
#define SIZE_FACTOR 1.2


using namespace std;

SimpleWindow CARROM("Carrom", 15.0*SIZE_FACTOR, 12.0*SIZE_FACTOR);

int ApiMain(){
	CARROM.Open();
	assert(CARROM.GetStatus()==WindowOpen);

//For the carrom frame

	CARROM.RenderRectangle(Position(0.0*SIZE_FACTOR,0.0*SIZE_FACTOR),Position(12.0*SIZE_FACTOR,12.0*SIZE_FACTOR),Black);
	CARROM.RenderRectangle(Position(1.0*SIZE_FACTOR,1.0*SIZE_FACTOR),Position(11.0*SIZE_FACTOR,11.0*SIZE_FACTOR),White);

//For the power bar and players and instruction message

	CARROM.RenderRectangle(Position(12.0*SIZE_FACTOR,0.0*SIZE_FACTOR),Position(15.0*SIZE_FACTOR,12.0*SIZE_FACTOR),Yellow);
	CARROM.RenderRectangle(Position(13.0*SIZE_FACTOR,3.0*SIZE_FACTOR),Position(14.0*SIZE_FACTOR,8.0*SIZE_FACTOR),White);
	CARROM.RenderText(Position(13.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Position(14.0*SIZE_FACTOR,9.0*SIZE_FACTOR),"Power Bar",Red);
	CARROM.RenderText(Position(13.0*SIZE_FACTOR,1.0*SIZE_FACTOR),Position(14.0*SIZE_FACTOR,2.5*SIZE_FACTOR),"Player 1",Blue);
	CARROM.RenderText(Position(13.0*SIZE_FACTOR,9.0*SIZE_FACTOR),Position(14.0*SIZE_FACTOR,10.5*SIZE_FACTOR),"Player 2",Blue);
	CARROM.RenderText(Position(13.0*SIZE_FACTOR,10.5*SIZE_FACTOR),Position(14.0*SIZE_FACTOR,11.5*SIZE_FACTOR),"Position Set",Blue);

//For the corner pockets

	CircleShape C(CARROM,Position(1.3*SIZE_FACTOR,1.3*SIZE_FACTOR),Black,0.6*SIZE_FACTOR);
	C.Draw();
	CircleShape D(CARROM,Position(1.3*SIZE_FACTOR,10.7*SIZE_FACTOR),Black,0.6*SIZE_FACTOR);
	D.Draw();
	CircleShape E(CARROM,Position(10.7*SIZE_FACTOR,1.3*SIZE_FACTOR),Black,0.6*SIZE_FACTOR);
	E.Draw();
	CircleShape F(CARROM,Position(10.7*SIZE_FACTOR,10.7*SIZE_FACTOR),Black,0.6*SIZE_FACTOR);
	F.Draw();

//For the side lines

	CARROM.RenderLine(Position(2.5*SIZE_FACTOR,3.0*SIZE_FACTOR),Position(2.5*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.05);
	CARROM.RenderLine(Position(2.9*SIZE_FACTOR,3.0*SIZE_FACTOR),Position(2.9*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.0);

	CARROM.RenderLine(Position(9.5*SIZE_FACTOR,3.0*SIZE_FACTOR),Position(9.5*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.05);
	CARROM.RenderLine(Position(9.1*SIZE_FACTOR,3.0*SIZE_FACTOR),Position(9.1*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.0);

	CARROM.RenderLine(Position(3.0*SIZE_FACTOR,2.5*SIZE_FACTOR),Position(9.0*SIZE_FACTOR,2.5*SIZE_FACTOR),Black,0.05);
	CARROM.RenderLine(Position(3.0*SIZE_FACTOR,2.9*SIZE_FACTOR),Position(9.0*SIZE_FACTOR,2.9*SIZE_FACTOR),Black,0.0);

	CARROM.RenderLine(Position(3.0*SIZE_FACTOR,9.5*SIZE_FACTOR),Position(9.0*SIZE_FACTOR,9.5*SIZE_FACTOR),Black,0.05);
	CARROM.RenderLine(Position(3.0*SIZE_FACTOR,9.1*SIZE_FACTOR),Position(9.0*SIZE_FACTOR,9.1*SIZE_FACTOR),Black,0.0);

//For the smaller red circles

	CircleShape G(CARROM,Position(2.7*SIZE_FACTOR,3.0*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
	G.Draw();
	CircleShape H(CARROM,Position(2.7*SIZE_FACTOR,3.01*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
	H.Draw();
	CircleShape I(CARROM,Position(2.7*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
	I.Draw();
	CircleShape J(CARROM,Position(2.7*SIZE_FACTOR,9.0*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
	J.Draw();

	CircleShape K(CARROM,Position(9.3*SIZE_FACTOR,3.0*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
	K.Draw();
	CircleShape L(CARROM,Position(9.3*SIZE_FACTOR,3.01*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
	L.Draw();
	CircleShape M(CARROM,Position(9.3*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
	M.Draw();
	CircleShape N(CARROM,Position(9.3*SIZE_FACTOR,9.0*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
	N.Draw();

	CircleShape O(CARROM,Position(3.0*SIZE_FACTOR,2.7*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
	O.Draw();
	CircleShape P(CARROM,Position(3.01*SIZE_FACTOR,2.7*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
	P.Draw();
	CircleShape Q(CARROM,Position(9.0*SIZE_FACTOR,2.7*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
	Q.Draw();
	CircleShape R(CARROM,Position(9.0*SIZE_FACTOR,2.7*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
	R.Draw();

	CircleShape S(CARROM,Position(3.0*SIZE_FACTOR,9.3*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
	S.Draw();
	CircleShape T(CARROM,Position(3.01*SIZE_FACTOR,9.3*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
	T.Draw();
	CircleShape U(CARROM,Position(9.0*SIZE_FACTOR,9.3*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
	U.Draw();
	CircleShape V(CARROM,Position(9.0*SIZE_FACTOR,9.3*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
	V.Draw();

//For the lines between the red circles

	CARROM.RenderLine(Position(2.0*SIZE_FACTOR,2.0*SIZE_FACTOR),Position(4.0*SIZE_FACTOR,4.0*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(2.0*SIZE_FACTOR,10.0*SIZE_FACTOR),Position(4.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(10.0*SIZE_FACTOR,10.0*SIZE_FACTOR),Position(8.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(8.0*SIZE_FACTOR,4.0*SIZE_FACTOR),Position(10.0*SIZE_FACTOR,2.0*SIZE_FACTOR),Black,0.0);

//For the central circle

	CircleShape m(CARROM,Position(6.0*SIZE_FACTOR,6.0*SIZE_FACTOR),White,3.0*SIZE_FACTOR);
	m.Draw();
	CircleShape n(CARROM,Position(6.0*SIZE_FACTOR,6.0*SIZE_FACTOR),Black,0.44*SIZE_FACTOR);
	n.Draw();
	CircleShape l(CARROM,Position(6.0*SIZE_FACTOR,6.0*SIZE_FACTOR),Red,0.4*SIZE_FACTOR);
	l.Draw();

//For the arrow at the end of lines between small red circles

	CARROM.RenderLine(Position(4.0*SIZE_FACTOR,4.0*SIZE_FACTOR),Position(3.8*SIZE_FACTOR,3.6*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(4.0*SIZE_FACTOR,4.0*SIZE_FACTOR),Position(3.6*SIZE_FACTOR,3.8*SIZE_FACTOR),Black,0.0);

	CARROM.RenderLine(Position(8.0*SIZE_FACTOR,4.0*SIZE_FACTOR),Position(8.2*SIZE_FACTOR,3.6*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(8.0*SIZE_FACTOR,4.0*SIZE_FACTOR),Position(8.4*SIZE_FACTOR,3.8*SIZE_FACTOR),Black,0.0);

	CARROM.RenderLine(Position(4.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Position(3.6*SIZE_FACTOR,8.2*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(4.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Position(3.8*SIZE_FACTOR,8.4*SIZE_FACTOR),Black,0.0);

	CARROM.RenderLine(Position(8.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Position(8.2*SIZE_FACTOR,8.4*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(8.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Position(8.4*SIZE_FACTOR,8.2*SIZE_FACTOR),Black,0.0);

//For the striker and pieces and the direction pointer

	CircleShape W(CARROM,Position(6.0*SIZE_FACTOR,9.3*SIZE_FACTOR),Yellow,0.5*SIZE_FACTOR);
	W.Draw();
	CARROM.RenderLine(Position(6.0*SIZE_FACTOR,9.3*SIZE_FACTOR),Position(6.0*SIZE_FACTOR,7.5*SIZE_FACTOR),Yellow,0.1);

	CircleShape X(CARROM,Position(4.875*SIZE_FACTOR,4.875*SIZE_FACTOR),Cyan,0.375*SIZE_FACTOR);
	X.Draw();
	CircleShape Y(CARROM,Position(4.875*SIZE_FACTOR,5.625*SIZE_FACTOR),Blue,0.375*SIZE_FACTOR);
	Y.Draw();
	CircleShape Z(CARROM,Position(4.875*SIZE_FACTOR,6.375*SIZE_FACTOR),Green,0.375*SIZE_FACTOR);
	Z.Draw();
	CircleShape A(CARROM,Position(4.875*SIZE_FACTOR,7.125*SIZE_FACTOR),Black,0.375*SIZE_FACTOR);
	A.Draw();
	CircleShape B(CARROM,Position(5.625*SIZE_FACTOR,4.875*SIZE_FACTOR),Black,0.375*SIZE_FACTOR);
	B.Draw();
	CircleShape a(CARROM,Position(5.625*SIZE_FACTOR,5.625*SIZE_FACTOR),Cyan,0.375*SIZE_FACTOR);
	a.Draw();
	CircleShape b(CARROM,Position(5.625*SIZE_FACTOR,6.375*SIZE_FACTOR),Blue,0.375*SIZE_FACTOR);
	b.Draw();
	CircleShape c(CARROM,Position(5.625*SIZE_FACTOR,7.125*SIZE_FACTOR),Green,0.375*SIZE_FACTOR);
	c.Draw();
	CircleShape d(CARROM,Position(6.375*SIZE_FACTOR,4.875*SIZE_FACTOR),Green,0.375*SIZE_FACTOR);
	d.Draw();
	CircleShape e(CARROM,Position(6.375*SIZE_FACTOR,5.625*SIZE_FACTOR),Black,0.375*SIZE_FACTOR);
	e.Draw();
	CircleShape f(CARROM,Position(6.375*SIZE_FACTOR,6.375*SIZE_FACTOR),Cyan,0.375*SIZE_FACTOR);
	f.Draw();
	CircleShape g(CARROM,Position(6.375*SIZE_FACTOR,7.125*SIZE_FACTOR),Blue,0.375*SIZE_FACTOR);
	g.Draw();
	CircleShape h(CARROM,Position(7.125*SIZE_FACTOR,4.875*SIZE_FACTOR),Blue,0.375*SIZE_FACTOR);
	h.Draw();
	CircleShape i(CARROM,Position(7.125*SIZE_FACTOR,5.625*SIZE_FACTOR),Green,0.375*SIZE_FACTOR);
	i.Draw();
	CircleShape j(CARROM,Position(7.125*SIZE_FACTOR,6.375*SIZE_FACTOR),Black,0.375*SIZE_FACTOR);
	j.Draw();
	CircleShape k(CARROM,Position(7.125*SIZE_FACTOR,7.125*SIZE_FACTOR),Cyan,0.375*SIZE_FACTOR);
	k.Draw();
	

	return 0;
}