#include<iostream>
#include<cassert>
#include "ezwin.h"
#include "position.h"
#include "rect.h"
#include "circle.h"
#include "triangle.h"
#include "square.h"
#include "wobject.h"
#include "shape.h"
#include "bitmap.h"
#include "label.h"

using namespace std;


int ApiMain()
{
SimpleWindow CARROM("Carrom", 12.0, 12.0,Position(0.0,0.0));

	CARROM.Open();

	assert(CARROM.GetStatus()==WindowOpen);

//For the carrom frame
CARROM.RenderRectangle(Position(0.0,0.0),Position(12.0,12.0),Black,0.001);
CARROM.RenderRectangle(Position(1.0,1.0),Position(11.0,11.0),White);
//For the corner pockets
 CircleShape C1 (CARROM, Position (1.3, 1.3), Blue, 1.1);
    C1.Draw();
CircleShape C2 (CARROM, Position (1.3,10.7), Blue, 1.1);
    C2.Draw();
CircleShape C3 (CARROM, Position (10.7, 1.3 ), Blue, 1.1);
    C3.Draw();
CircleShape C4 (CARROM, Position (10.7, 10.7),Blue, 1.1);
    C4.Draw();

	
//For the side lines
         CARROM.RenderLine (Position(2.5,3.0),Position(2.5,9.0),Black,0.05);
	CARROM.RenderLine (Position(2.9,3.0),Position(2.9,9.0),Black,0.005);

        CARROM.RenderLine (Position(9.5,3.0),Position(9.5,9.0),Black,0.05);
	CARROM.RenderLine (Position(9.1,3.0),Position(9.1,9.0),Black,0.005);

	CARROM.RenderLine (Position(3.0,2.5),Position(9.0,2.5),Black,0.05);
	CARROM.RenderLine (Position(3.0,2.9),Position(9.0,2.9),Black,0.005);

	CARROM.RenderLine (Position(3.0,9.5),Position(9.0,9.5),Black,0.05);
	CARROM.RenderLine (Position(3.0,9.1),Position(9.0,9.1),Black,0.005);

	
//For the smaller red circles

CircleShape C5 (CARROM, Position (2.7, 3.0), White,0.4 );
    C5.Draw();
CircleShape C6 (CARROM, Position (2.7,3.0), Red, 0.35);
    C6.Draw();
CircleShape C7 (CARROM, Position (2.7, 9.0 ), White, 0.4);
    C7.Draw();
CircleShape C8 (CARROM, Position (2.7, 9.0), Red, 0.35);
    C8.Draw();
CircleShape C9 (CARROM, Position (9.3, 3.0), White, 0.4);
    C9.Draw();
CircleShape C10 (CARROM, Position (9.3,3.0), Red, 0.35);
    C10.Draw();
CircleShape C11 (CARROM, Position (9.3,9.0 ), White, 0.4);
    C11.Draw();
CircleShape C12 (CARROM, Position (9.3, 9.0), Red, 0.35);
    C12.Draw();
CircleShape C13 (CARROM, Position (3.0, 2.7), White,0.4 );
    C13.Draw();
CircleShape C14 (CARROM, Position (3.0,2.7), Red, 0.35);
    C14.Draw();
CircleShape C15 (CARROM, Position (9.0,2.7 ), White, 0.4);
    C15.Draw();
CircleShape C16 (CARROM, Position (9.0,2.7), Red, 0.35);
    C16.Draw();
CircleShape C17 (CARROM, Position (3.0, 9.3), White, 0.4);
    C17.Draw();
CircleShape C18 (CARROM, Position (3.0,9.3), Red, 0.35);
    C18.Draw();
CircleShape C19 (CARROM, Position (9.0,9.3), White, 0.4);
    C19.Draw();
CircleShape C20 (CARROM, Position (9.0, 9.3), Red, 0.35);
    C20.Draw();
//For the lines between the red circles

	CARROM.RenderLine (Position(2.0,2.0),Position(4.0,4.0),Black,0.0);
	CARROM.RenderLine (Position(2.0,10.0),Position(4.0,8.0),Black,0.0);
	CARROM.RenderLine (Position(10.0,10.0),Position(8.0,8.0),Black,0.0);
	CARROM.RenderLine (Position(8.0,4.0),Position(10.0,2.0),Black,0.0);
//For the center circle
CircleShape C21 (CARROM, Position (6.0, 6.0), Red, 1.5);
    C21.Draw();
CircleShape C22 (CARROM, Position (6.0, 6.0), White, 1.0);
    C22.Draw();
//For the arrow at the end of lines between small red circles

	CARROM.RenderLine (Position(4.0,4.0),Position(3.8,3.6),Black,0.0);
	CARROM.RenderLine (Position(4.0,4.0),Position(3.6,3.8),Black,0.0);

	CARROM.RenderLine (Position(8.0,4.0),Position(8.2,3.6),Black,0.0);
	CARROM.RenderLine (Position(8.0,4.0),Position(8.4,3.8),Black,0.0);

	CARROM.RenderLine (Position(4.0,8.0),Position(3.6,8.2),Black,0.0);
	CARROM.RenderLine (Position(4.0,8.0),Position(3.8,8.4),Black,0.0);

	CARROM.RenderLine (Position(8.0,8.0),Position(8.2,8.4),Black,0.0);
	CARROM.RenderLine (Position(8.0,8.0),Position(8.4,8.2),Black,0.0);
//Line for central circle
	CARROM.RenderLine (Position(6.0,6.5),Position(6.0,5.5),Black,0.0);
	CARROM.RenderLine (Position(5.5,6.0),Position(6.5,6.0),Black,0.0);
	CircleShape C23 (CARROM, Position (6.0, 6.0), Black, 0.1);
    C23.Draw();

	
cout << "Type Ctrl-C to remove the display and exit" << endl;
  char AnyChar;
  cin >> AnyChar;

CARROM.Close();

return 0;
}
