#include<iostream>
#include<cassert>
#include"ezwin.h"
#include"rect.h"
#include"circle.h"
#include"ellipse.h"
#include"shape.h"
#include"position.h"
#include "bitmap.h"
using namespace std;

SimpleWindow WelcomeScreen("Welcome",20.0,14.0);
BitMap start(WelcomeScreen);


//Function to open the Welcome screen and display the contents of the window.
int Open_Welcome_Screen(){
	WelcomeScreen.Open();
	assert(WelcomeScreen.GetStatus()==WindowOpen);

	//Background and main titles

	WelcomeScreen.RenderRectangle(Position(0.0,0.0),Position(20.0,14.0),Black);

	//Main title "CARROM-171"

	CircleShape a(WelcomeScreen,Position(2.5,2.0),Cyan,4.0);
	a.Draw();
	WelcomeScreen.RenderRectangle(Position(2.5,0.0),Position(4.5,4.0),Black);
	CircleShape f(WelcomeScreen,Position(2.5,2.0),Black,3.75);
	f.Draw();
	WelcomeScreen.RenderRectangle(Position(2.5,0.0),Position(4.5,4.0),Black);
	EllipseShape b(WelcomeScreen,Position(8.0,1.0),Cyan,4.0,2.0);
	b.Draw();
	EllipseShape g(WelcomeScreen,Position(8.0,1.0),Black,3.75,1.75);
	g.Draw();
	WelcomeScreen.RenderRectangle(Position(6.0,0.0),Position(8.0,4.0),Black);
	EllipseShape c(WelcomeScreen,Position(5.5,1.0),Cyan,4.0,2.0);
	c.Draw();
	EllipseShape h(WelcomeScreen,Position(5.5,1.0),Black,3.75,1.75);
	h.Draw();
	WelcomeScreen.RenderRectangle(Position(3.5,0.0),Position(5.5,4.0),Black);
	WelcomeScreen.RenderLine(Position(4.0,0.0),Position(3.0,4.0),Cyan,0.1);
	WelcomeScreen.RenderLine(Position(4.0,0.0),Position(5.0,4.0),Cyan,0.1);
	WelcomeScreen.RenderLine(Position(3.25,2.5),Position(4.75,2.5),Cyan,0.1);
	WelcomeScreen.RenderLine(Position(5.5,0.0),Position(5.5,4.0),Cyan,0.1);
	WelcomeScreen.RenderLine(Position(5.5,2.0),Position(7.5,4.0),Cyan,0.1);
	WelcomeScreen.RenderLine(Position(8.0,0.0),Position(8.0,4.0),Cyan,0.1);
	WelcomeScreen.RenderLine(Position(8.0,2.0),Position(10.0,4.0),Cyan,0.1);
	EllipseShape d(WelcomeScreen,Position(11.75,2.0),Cyan,2.5,4.0);
	d.Draw();
	EllipseShape e(WelcomeScreen,Position(11.75,2.0),Black,2.25,3.75);
	e.Draw();
	WelcomeScreen.RenderLine(Position(13.5,0.0),Position(13.5,4.0),Cyan,0.1);
	WelcomeScreen.RenderLine(Position(15.5,0.0),Position(15.5,4.0),Cyan,0.1);
	WelcomeScreen.RenderLine(Position(15.5,0.0),Position(14.5,2.0),Cyan,0.1);
	WelcomeScreen.RenderLine(Position(13.5,0.0),Position(14.5,2.0),Cyan,0.1);
	WelcomeScreen.RenderLine(Position(16.0,2.0),Position(16.5,2.0),Cyan,0.1);
	WelcomeScreen.RenderLine(Position(17.0,0.0),Position(17.0,4.0),Cyan,0.1);
	WelcomeScreen.RenderLine(Position(17.0,0.0),Position(16.5,1.0),Cyan,0.1);
	WelcomeScreen.RenderLine(Position(16.75,4.0),Position(17.25,4.0),Cyan,0.1);
	WelcomeScreen.RenderLine(Position(17.75,0.05),Position(18.75,0.05),Cyan,0.1);
	WelcomeScreen.RenderLine(Position(18.75,0.0),Position(18.0,4.0),Cyan,0.1);
	WelcomeScreen.RenderLine(Position(19.5,0.0),Position(19.5,4.0),Cyan,0.1);
	WelcomeScreen.RenderLine(Position(19.5,0.0),Position(19.0,1.0),Cyan,0.1);
	WelcomeScreen.RenderLine(Position(19.25,4.0),Position(19.75,4.0),Cyan,0.1);

	//Other 4 options, START GAME, HOW TO PLAY, CREDITS, EXIT

	WelcomeScreen.RenderText(Position(6.0,4.5),Position(14.0,6.5),"START GAME",Cyan,Black);
	WelcomeScreen.RenderText(Position(6.0,6.5),Position(14.0,8.5),"HOW TO PLAY",Cyan,Black);
	WelcomeScreen.RenderText(Position(6.0,8.5),Position(14.0,10.5),"CREDITS",Cyan,Black);
	WelcomeScreen.RenderText(Position(6.0,10.5),Position(14.0,12.5),"EXIT GAME",Cyan,Black);
	WelcomeScreen.RenderText(Position(5.0,12.5),Position(15.0,14.0),"CLICK ON THE OPTION YOU WISH TO SELECT TO PROCEED.",Cyan,Black);
	
	WelcomeScreen.SetMouseClickCallback(WelcomeScreenMouseClick);
	return 1;
}

//Function to control the mouse in the credits window
int CreditsMouseClick(const Position &p){
	float x=p.GetXDistance(),y=p.GetYDistance();
	if(x>12.4 && x<16.4 && y<14.0 && y>13.5){
		Credits.Close();
		Open_Welcome_Screen();
		return 1;
	}
	else{
		Credits.SetMouseClickCallback(CreditsMouseClick);
	}
}

//Funtion to control the mouse in the How_to_play window
int How_to_playMouseClick(const Position &p){
	float x=p.GetXDistance(),y=p.GetYDistance();
	if(x>11.0 && x<15.0 && y<14.0 && y>13.5){
		How_to_play.Close();
		Open_Welcome_Screen();
		return 1;
	}
	else{
		How_to_play.SetMouseClickCallback(How_to_playMouseClick);
	}
}

//Funtion to control the mouse in the WelcomeScreen window
int WelcomeScreenMouseClick(const Position &p){
	float x=p.GetXDistance(),y=p.GetYDistance();
	if(x<14.0 && x>6.0 && y>8.5 && y<10.5){
		WelcomeScreen.Close();
		Credits.Open();
		assert(Credits.GetStatus()==WindowOpen);

		//Background and details

		Credits.RenderRectangle(Position(0.0,0.0),Position(16.6,14.0),Black);

		//Top title "TEAM-171"

		Credits.RenderLine(Position(1.0,0.05),Position(3.0,0.05),Cyan,0.1);
		Credits.RenderLine(Position(2.0,0.0),Position(2.0,4.0),Cyan,0.1);
		Credits.RenderLine(Position(3.5,0.0),Position(3.5,4.0),Cyan,0.1);
		Credits.RenderLine(Position(3.5,0.05),Position(5.5,0.05),Cyan,0.1);
		Credits.RenderLine(Position(3.5,2.0),Position(4.5,2.0),Cyan,0.1);
		Credits.RenderLine(Position(3.5,4.0),Position(5.5,4.0),Cyan,0.1);
		Credits.RenderLine(Position(7.0,0.0),Position(6.0,4.0),Cyan,0.1);
		Credits.RenderLine(Position(7.0,0.0),Position(8.0,4.0),Cyan,0.1);
		Credits.RenderLine(Position(6.25,2.75),Position(7.75,2.75),Cyan,0.1);
		Credits.RenderLine(Position(8.5,0.0),Position(8.5,4.0),Cyan,0.1);
		Credits.RenderLine(Position(10.5,0.0),Position(10.5,4.0),Cyan,0.1);
		Credits.RenderLine(Position(10.5,0.0),Position(9.5,2.0),Cyan,0.1);
		Credits.RenderLine(Position(8.5,0.0),Position(9.5,2.0),Cyan,0.1);
		Credits.RenderLine(Position(11.0,2.0),Position(12.0,2.0),Cyan,0.1);
		Credits.RenderLine(Position(12.5,0.0),Position(12.5,4.0),Cyan,0.1);
		Credits.RenderLine(Position(12.5,0.0),Position(12.0,1.0),Cyan,0.1);
		Credits.RenderLine(Position(12.125,4.0),Position(12.875,4.0),Cyan,0.1);
		Credits.RenderLine(Position(13.0,0.05),Position(14.5,0.05),Cyan,0.1);
		Credits.RenderLine(Position(14.5,0.0),Position(13.25,4.0),Cyan,0.1);
		Credits.RenderLine(Position(15.25,0.0),Position(15.25,4.0),Cyan,0.1);
		Credits.RenderLine(Position(15.25,0.0),Position(14.75,1.0),Cyan,0.1);
		Credits.RenderLine(Position(14.875,4.0),Position(15.575,4.0),Cyan,0.1);

		//Team members

		Credits.RenderText(Position(5.3,4.5),Position(11.3,5.5),"TOSHENDRA SHARMA (T.A. AND MENTOR)",Cyan,Black);
		Credits.RenderText(Position(5.3,5.5),Position(11.3,6.5),"TEJAS SONI (TEAM LEADER)",Cyan,Black);
		Credits.RenderText(Position(5.3,6.5),Position(11.3,7.5),"VAMSIDHAR Y.",Cyan,Black);
		Credits.RenderText(Position(5.3,7.5),Position(11.3,8.5),"VIVAN SORAB",Cyan,Black);
		Credits.RenderText(Position(5.3,8.5),Position(11.3,9.5),"TARKESHWAR SINGH",Cyan,Black);
		Credits.RenderText(Position(5.3,9.5),Position(11.3,10.5),"SURESH CHAND MEENA",Cyan,Black);
		Credits.RenderText(Position(5.3,10.5),Position(11.3,11.5),"SUNNY KATARIA",Cyan,Black);
		Credits.RenderText(Position(5.3,11.5),Position(11.3,12.5),"SAI KRISHNA R.",Cyan,Black);
		Credits.RenderText(Position(5.3,12.5),Position(11.3,13.5),"VIPUL SNEHI",Cyan,Black);
		Credits.RenderText(Position(12.4,13.5),Position(16.4,14.0),"CLICK HERE TO GO BACK",Cyan,Black);
		Credits.SetMouseClickCallback(CreditsMouseClick);
	}
	else if(x>6.0 && x<14.0 && y>6.5 && y<8.5){
		WelcomeScreen.Close();
		How_to_play.Open();
		assert(How_to_play.GetStatus()==WindowOpen);

		//Background and the details

		How_to_play.RenderRectangle(Position(0.0,0.0),Position(16.0,14.0),Black);
		How_to_play.RenderText(Position(1.0,0.0),Position(15.0,1.0),"..::RULES OF THE GAME::..",Cyan,Black);
		How_to_play.RenderText(Position(1.0,1.0),Position(15.0,1.5),"The game is similar to the original game. The game was introduced in",Cyan,Black);
		How_to_play.RenderText(Position(1.0,1.5),Position(15.0,2.0),"India. This game is designed for two players. Both players get alternate",Cyan,Black);
		How_to_play.RenderText(Position(1.0,2.0),Position(15.0,2.5),"turns to shoot. The striker is used to shoot other pieces on the board.",Cyan,Black);
		How_to_play.RenderText(Position(1.0,2.5),Position(15.0,3.0),"The striker has to be placed between the base lines. There are 16 pieces,",Cyan,Black);
		How_to_play.RenderText(Position(1.0,3.0),Position(15.0,3.5),"four of each of the following colors: Cyan, Blue, Green and Black.",Cyan,Black);
		How_to_play.RenderText(Position(1.0,3.5),Position(15.0,4.0),"Each color has an associated value to it:",Cyan,Black);
		How_to_play.RenderText(Position(1.0,4.0),Position(15.0,4.5),"Cyan - 50 points",Cyan,Black);
		How_to_play.RenderText(Position(1.0,4.5),Position(15.0,5.0),"Blue - 40 points",Cyan,Black);
		How_to_play.RenderText(Position(1.0,5.0),Position(15.0,5.5),"Green - 25 points",Cyan,Black);
		How_to_play.RenderText(Position(1.0,5.5),Position(15.0,6.0),"Black - 10 points",Cyan,Black);
		How_to_play.RenderText(Position(1.0,6.0),Position(15.0,6.5),"All colors are open to both players and they score points corresponding",Cyan,Black);
		How_to_play.RenderText(Position(1.0,6.5),Position(15.0,7.0),"to the color of the piece they sink in any of the four pockets at the",Cyan,Black);
		How_to_play.RenderText(Position(1.0,7.0),Position(15.0,7.5),"corners. For sinking the striker a penalty of 10 points is given. At",Cyan,Black);
		How_to_play.RenderText(Position(1.0,7.5),Position(15.0,8.0),"the end of the game, the person with more points wins.",Cyan,Black);
		How_to_play.RenderText(Position(1.0,8.0),Position(15.0,9.0),"..::HOW TO PLAY::..",Cyan,Black);
		How_to_play.RenderText(Position(1.0,9.0),Position(15.0,9.5),"The first step is to set the position of the striker. Using the mouse,",Cyan,Black);
		How_to_play.RenderText(Position(1.0,9.5),Position(15.0,10.0),"click on the position between the base lines where you want the striker",Cyan,Black);
		How_to_play.RenderText(Position(1.0,10.0),Position(15.0,10.5),"to be placed. Once you select the position, confirm it by clicking on",Cyan,Black);
		How_to_play.RenderText(Position(1.0,10.5),Position(15.0,11.0),"POSITION SET at the bottom-right of the board. Next, select the",Cyan,Black);
		How_to_play.RenderText(Position(1.0,11.0),Position(15.0,11.5),"direction in which you want to shoot the striker by clicking in the",Cyan,Black);
		How_to_play.RenderText(Position(1.0,11.5),Position(15.0,12.0),"direction. Once you select the angle, confirm it by clicking on ANGLE",Cyan,Black);
		How_to_play.RenderText(Position(1.0,12.0),Position(15.0,12.5),"SET. Next, select the power with which you want to shoot the striker",Cyan,Black);
		How_to_play.RenderText(Position(1.0,12.5),Position(15.0,13.0),"by clicking in the power bar at the appropriate level. Once done,",Cyan,Black);
		How_to_play.RenderText(Position(1.0,13.0),Position(15.0,13.5),"click on POWER SET and then click on SHOOT! to make your shot. Enjoy!",Cyan,Black);
		How_to_play.RenderText(Position(11.0,13.5),Position(15.0,14.0),"CLICK HERE TO GO BACK",Cyan,Black);
		How_to_play.SetMouseClickCallback(How_to_playMouseClick);
	}
