#ifndef SCORE_SCREEN_H_INCLUDED
#define SCORE_SCREEN_H_INCLUDED

SimpleWindow Score_Screen("Score:",11.0,11.0,Position(5.0,2.0));//Defining the simple window

void Open_Display_Score_Screen();//Function to display the score after the game finishes
int Score_ScreenMouseClick(const Position &p);//Function to control mouse clicks in the Score_Screen window

//Function to control mouse clicks in the Score_Screen window
int Score_ScreenMouseClick(const Position &p){
	if(p.GetXDistance()<=4.0 && p.GetXDistance()>=0.0 && p.GetYDistance()<=11.0 && p.GetYDistance()>=10.0){//Checking if the click is in the GO TO MAIN MENU button and acting accordingly
		Score_Screen.Close();
		Open_Welcome_Screen();
	}
	if(p.GetXDistance()<=9.0 && p.GetXDistance()>=4.5 && p.GetYDistance()<=11.0 && p.GetYDistance()>=10.0){//Checking if the click is on the PLAY AGAIN button and acting accordingly
		Score_Screen.Close();
		Player_1.update_score(0);
		Player_2.update_score(0);
		Open_CARROM_screen();
	}
	if(p.GetXDistance()<=11.0 && p.GetXDistance()>=9.0 && p.GetYDistance()<=11.0 && p.GetYDistance()>=10.0){//Checking if the click is on the EXIT button and acting accordingly
		Score_Screen.Close();
		exit(0);
	}
}

//Function to display the score after the game finishes
void Open_Display_Score_Screen(){
	int temp;
	CARROM.Close();
	Score_Screen.Open();//Opening window to display the final score
	assert(Score_Screen.GetStatus()==WindowOpen);//Checking if window opened
	Score_Screen.RenderRectangle(Position(0.0,0.0),Position(11.0,11.0),Black);
	Score_Screen.RenderText(Position(2.0,0.0),Position(4.0,2.0),Player_1.give_name(),Red,Cyan);
	Score_Screen.RenderText(Position(2.0,2.0),Position(4.0,4.0),Player_2.give_name(),Red,Cyan);
	Score_Screen.RenderText(Position(5.0,0.0),Position(6.0,2.0),":",Red,Cyan);
	Score_Screen.RenderText(Position(5.0,2.0),Position(6.0,4.0),":",Red,Cyan);
	Score_Screen.RenderText(Position(7.0,0.0),Position(9.0,2.0),Player_1.give_score(),Red,Cyan);
	Score_Screen.RenderText(Position(7.0,2.0),Position(9.0,4.0),Player_2.give_score(),Red,Cyan);
	temp=Player_1.compare_score(Player_2.give_score());
	if(temp==1){//That is, if Player_1 has a higher score
		Score_Screen.RenderText(Position(3.0,4.0),Position(5.5,6.0),Player_1.give_name(),Red,Cyan);
		Score_Screen.RenderText(Position(5.5,4.0),Position(11.0,6.0),"Wins!",Red,Cyan);
		Score_Screen.RenderText(Position(3.0,6.0),Position(8.0,8.0),"CONGRATULATIONS! Well Played!",Red,Cyan);
		Score_Screen.RenderText(Position(0.0,8.0),Position(5.5,10.0),"Better luck next time",Red,Cyan);
		Score_Screen.RenderText(Position(5.5,8.0),Position(11.0,10.0),Player_2.give_name(),Red,Cyan);
	}
	else if(temp==-1){//That is, if Player_2 has a higher score
		Score_Screen.RenderText(Position(2.0,4.0),Position(5.5,6.0),Player_2.give_name(),Red,Cyan);
		Score_Screen.RenderText(Position(5.5,4.0),Position(11.0,6.0),"Wins!",Red,Cyan);
		Score_Screen.RenderText(Position(3.0,6.0),Position(8.0,8.0),"CONGRATULATIONS! Well Played!",Red,Cyan);
		Score_Screen.RenderText(Position(0.0,8.0),Position(5.5,10.0),"Better luck next time",Red,Cyan);
		Score_Screen.RenderText(Position(5.5,8.0),Position(11.0,10.0),Player_1.give_name(),Red,Cyan);
	}
	else{//In case of a tie
		Score_Screen.RenderText(Position(3.0,4.0),Position(5.5,7.0),"It's a tie!",Red,Cyan);
		Score_Screen.RenderText(Position(5.5,7.0),Position(8.0,10.0),"Well played, both of you!",Red,Cyan);
	}
	Score_Screen.RenderText(Position(0.0,10.0),Position(4.0,11.0),"GO TO MAIN MENU",Red,Cyan);
	Score_Screen.RenderText(Position(4.5,10.0),Position(9.0,11.0),"PLAY AGAIN",Red,Cyan);
	Score_Screen.RenderText(Position(9.0,10.0),Position(11.0,11.0),"EXIT",Red,Cyan);
	Score_Screen.SetMouseClickCallback(Score_ScreenMouseClick);
}
#endif
