#include<iostream>
#include<cassert>
#include<bitmap.h>

// Define  window
SimpleWindow W1("Window One", 25.0, 15.0, Position(1.0, 1.0));

// Define a bitmap object
BitMap W1Bmp(W1);

// W1MouseClick(): call back function for Window one
int W1MouseClick(const Position &p) {
	Position P=p;
	P.SetYDistance(1.0);
	float power=0.1;
	for(float i=1.0;i<=15.0;i+=0.01){
		W1Bmp.Erase();
		P.SetXDistance(i);
		W1Bmp.SetPosition(P);
		W1Bmp.Draw();
		if(100*i/power>7000)break;
		usleep(100*i/power);
	}
	return 1;
}

int ApiMain() {

	// Open the windows
	W1.Open();
	assert(W1.GetStatus() == WindowOpen);

	// Load the images
	// **********************
	// Is the image not in xpm format?  Don't worry, use the convert
	// command.  E.g. if you have image.bmp, use the following:
	//     convert image.bmp image.xpm 
	// **********************
	 W1Bmp.Load("Striker.xpm");
//	W1Bmp.Load("fingerprint11.xpm");
	//W1Bmp.Load("trbot-r.xpm");
	assert(W1Bmp.GetStatus() == BitMapOkay);

	// Display the bit maps at a starting position
	W1Bmp.SetPosition(Position(1.0, 1.0));
	W1Bmp.Draw();

	// Register the call backs for each window
	W1.SetMouseClickCallback(W1MouseClick);
	return 0;
}
