#include<iostream>
#include<cassert>
#include"ezwin.h"
#include"rect.h"
#include"circle.h"
#include"ellipse.h"
#include"shape.h"
#include"position.h"
#include"bitmap.h"
#include<cmath>
#include<cstring>
#include<stdio.h>

#define SIZE_FACTOR 1.2
using namespace std;

SimpleWindow WelcomeScreen("Welcome",20.0,14.0);
SimpleWindow Credits("Credits",16.6,14.0);
SimpleWindow How_to_play("How to play",16.0,14.0);
SimpleWindow CARROM("Carrom", 15.0*SIZE_FACTOR, 12.0*SIZE_FACTOR);
//Definitions of all the functions, classes and global variables used in the program
int WelcomeScreenMouseClick(const Position &p);//Function to control the mouse in the WelcomeScreen window
int CreditsMouseClick(const Position &p);//Function to control the mouse in the Credits window
int How_to_playMouseClick(const Position &p);//Function to control the mouse in the How_to_play window
int Open_Welcome_Screen();//Function to open the WelcomeScreen
int CARROMMouseClick(const Position &p);//Function to control the mouse in the CARROM window
Position calculate_end_point(Position X,Position Y);//Function to calculate the end point of the angle line
void display_carrom_background();//Function to show the background of the carrom
void Shoot();//Function to shoot the striker
class Player{
	private:
	char name[20];
	int score;
	public:
	Player(){
		score=0;
	}
	void set_name(char x[20]){
		strcpy(name,x);
	}
	void update_score(int x){
		score=score+x;
	}
	char* give_name(){
		return name;
	}
	char* give_score(){
		char charscore[4]="000";
		if(score!=0){
			charscore[2]=score/10;
			charscore[1]=(score/100)%10;
			charscore[0]=(score/1000)%100;
		}
		return charscore;
	}
}Player_1,Player_2;

int flag=0,turn=0,balls_remaining=16,foul=0;
float power=0.0*SIZE_FACTOR,theta;
char player_score[15]="Score: ";
Position striker,cyan1,cyan2,cyan3,cyan4,green1,green2,green3,green4,black1,black2,black3,black4,blue1,blue2,blue3,blue4;

BitMap Striker(CARROM);
BitMap Cyan1(CARROM);
BitMap Cyan2(CARROM);
BitMap Cyan3(CARROM);
BitMap Cyan4(CARROM);
BitMap Green1(CARROM);
BitMap Green2(CARROM);
BitMap Green3(CARROM);
BitMap Green4(CARROM);
BitMap Blue1(CARROM);
BitMap Blue2(CARROM);
BitMap Blue3(CARROM);
BitMap Blue4(CARROM);
BitMap Black1(CARROM);
BitMap Black2(CARROM);
BitMap Black3(CARROM);
BitMap Black4(CARROM);

//The most important function Shoot, to shoot the striker and move the pieces according to physics
void Shoot(){
	


}

//Function to show the background of the carrom
void display_carrom_background(){
	//For the carrom frame
	CARROM.RenderRectangle(Position(0.0*SIZE_FACTOR,0.0*SIZE_FACTOR),Position(12.0*SIZE_FACTOR,12.0*SIZE_FACTOR),Yellow);
	CARROM.RenderRectangle(Position(1.0*SIZE_FACTOR,1.0*SIZE_FACTOR),Position(11.0*SIZE_FACTOR,11.0*SIZE_FACTOR),White);
	//For the power bar and players and instruction message
	CARROM.RenderRectangle(Position(12.0*SIZE_FACTOR,0.0*SIZE_FACTOR),Position(15.0*SIZE_FACTOR,12.0*SIZE_FACTOR),Black);
	CARROM.RenderRectangle(Position(13.0*SIZE_FACTOR,3.0*SIZE_FACTOR),Position(14.0*SIZE_FACTOR,8.0*SIZE_FACTOR),White);
	CARROM.RenderText(Position(13.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Position(14.0*SIZE_FACTOR,9.0*SIZE_FACTOR),"POWER BAR",Red,Black);
	CARROM.RenderText(Position(12.0*SIZE_FACTOR,1.0*SIZE_FACTOR),Position(15.0*SIZE_FACTOR,2.0*SIZE_FACTOR),Player_1.give_name(),Red,Black);
	CARROM.RenderText(Position(12.0*SIZE_FACTOR,9.0*SIZE_FACTOR),Position(15.0*SIZE_FACTOR,10.0*SIZE_FACTOR),Player_2.give_name(),Red,Black);
	strcat(player_score,Player_1.give_score());
	CARROM.RenderText(Position(12.0*SIZE_FACTOR,2.0*SIZE_FACTOR),Position(15.0*SIZE_FACTOR,3.0*SIZE_FACTOR),player_score,Red,Black);
	strcpy(player_score,"Score: ");
	strcat(player_score,Player_2.give_score());
	CARROM.RenderText(Position(12.0*SIZE_FACTOR,10.0*SIZE_FACTOR),Position(15.0*SIZE_FACTOR,11.0*SIZE_FACTOR),player_score,Red,Black);
	strcpy(player_score,"Score: ");
	CARROM.RenderText(Position(13.0*SIZE_FACTOR,11.0*SIZE_FACTOR),Position(14.0*SIZE_FACTOR,12.0*SIZE_FACTOR),"POSITION SET",Red,Black);
	//For the corner pockets
	CircleShape C(CARROM,Position(1.3*SIZE_FACTOR,1.3*SIZE_FACTOR),Black,0.6*SIZE_FACTOR);
	C.Draw();
	CircleShape D(CARROM,Position(1.3*SIZE_FACTOR,10.7*SIZE_FACTOR),Black,0.6*SIZE_FACTOR);
	D.Draw();
	CircleShape E(CARROM,Position(10.7*SIZE_FACTOR,1.3*SIZE_FACTOR),Black,0.6*SIZE_FACTOR);
	E.Draw();
	CircleShape F(CARROM,Position(10.7*SIZE_FACTOR,10.7*SIZE_FACTOR),Black,0.6*SIZE_FACTOR);
	F.Draw();
	//For the side lines
	CARROM.RenderLine(Position(2.5*SIZE_FACTOR,3.0*SIZE_FACTOR),Position(2.5*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.05);
	CARROM.RenderLine(Position(2.9*SIZE_FACTOR,3.0*SIZE_FACTOR),Position(2.9*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(9.5*SIZE_FACTOR,3.0*SIZE_FACTOR),Position(9.5*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.05);
	CARROM.RenderLine(Position(9.1*SIZE_FACTOR,3.0*SIZE_FACTOR),Position(9.1*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(3.0*SIZE_FACTOR,2.5*SIZE_FACTOR),Position(9.0*SIZE_FACTOR,2.5*SIZE_FACTOR),Black,0.05);
	CARROM.RenderLine(Position(3.0*SIZE_FACTOR,2.9*SIZE_FACTOR),Position(9.0*SIZE_FACTOR,2.9*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(3.0*SIZE_FACTOR,9.5*SIZE_FACTOR),Position(9.0*SIZE_FACTOR,9.5*SIZE_FACTOR),Black,0.05);
	CARROM.RenderLine(Position(3.0*SIZE_FACTOR,9.1*SIZE_FACTOR),Position(9.0*SIZE_FACTOR,9.1*SIZE_FACTOR),Black,0.0);
	//For the smaller red circles
	CircleShape G(CARROM,Position(2.7*SIZE_FACTOR,3.0*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
	G.Draw();
	CircleShape H(CARROM,Position(2.7*SIZE_FACTOR,3.01*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
	H.Draw();
	CircleShape I(CARROM,Position(2.7*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
	I.Draw();
	CircleShape J(CARROM,Position(2.7*SIZE_FACTOR,9.0*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
	J.Draw();
	CircleShape K(CARROM,Position(9.3*SIZE_FACTOR,3.0*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
	K.Draw();
	CircleShape L(CARROM,Position(9.3*SIZE_FACTOR,3.01*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
	L.Draw();
	CircleShape M(CARROM,Position(9.3*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
	M.Draw();
	CircleShape N(CARROM,Position(9.3*SIZE_FACTOR,9.0*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
	N.Draw();
	CircleShape O(CARROM,Position(3.0*SIZE_FACTOR,2.7*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
	O.Draw();
	CircleShape P(CARROM,Position(3.01*SIZE_FACTOR,2.7*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
	P.Draw();
	CircleShape Q(CARROM,Position(9.0*SIZE_FACTOR,2.7*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
	Q.Draw();
	CircleShape R(CARROM,Position(9.0*SIZE_FACTOR,2.7*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
	R.Draw();
	CircleShape S(CARROM,Position(3.0*SIZE_FACTOR,9.3*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
	S.Draw();
	CircleShape T(CARROM,Position(3.01*SIZE_FACTOR,9.3*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
	T.Draw();
	CircleShape U(CARROM,Position(9.0*SIZE_FACTOR,9.3*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
	U.Draw();
	CircleShape V(CARROM,Position(9.0*SIZE_FACTOR,9.3*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
	V.Draw();
	//For the lines between the red circles
	CARROM.RenderLine(Position(2.0*SIZE_FACTOR,2.0*SIZE_FACTOR),Position(4.0*SIZE_FACTOR,4.0*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(2.0*SIZE_FACTOR,10.0*SIZE_FACTOR),Position(4.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(10.0*SIZE_FACTOR,10.0*SIZE_FACTOR),Position(8.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(8.0*SIZE_FACTOR,4.0*SIZE_FACTOR),Position(10.0*SIZE_FACTOR,2.0*SIZE_FACTOR),Black,0.0);
	//For the centeral circle
	CircleShape m(CARROM,Position(6.0*SIZE_FACTOR,6.0*SIZE_FACTOR),White,3.0*SIZE_FACTOR);
	m.Draw();
	CircleShape n(CARROM,Position(6.0*SIZE_FACTOR,6.0*SIZE_FACTOR),Black,0.44*SIZE_FACTOR);
	n.Draw();
	CircleShape l(CARROM,Position(6.0*SIZE_FACTOR,6.0*SIZE_FACTOR),Red,0.4*SIZE_FACTOR);
	l.Draw();
	//For the arrow at the end of lines between small red circles
	CARROM.RenderLine(Position(4.0*SIZE_FACTOR,4.0*SIZE_FACTOR),Position(3.8*SIZE_FACTOR,3.6*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(4.0*SIZE_FACTOR,4.0*SIZE_FACTOR),Position(3.6*SIZE_FACTOR,3.8*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(8.0*SIZE_FACTOR,4.0*SIZE_FACTOR),Position(8.2*SIZE_FACTOR,3.6*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(8.0*SIZE_FACTOR,4.0*SIZE_FACTOR),Position(8.4*SIZE_FACTOR,3.8*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(4.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Position(3.6*SIZE_FACTOR,8.2*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(4.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Position(3.8*SIZE_FACTOR,8.4*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(8.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Position(8.2*SIZE_FACTOR,8.4*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(8.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Position(8.4*SIZE_FACTOR,8.2*SIZE_FACTOR),Black,0.0);
}

//Function to calculate the end point of the angle line
Position calculate_end_point(Position X,Position Y){
	Position z;
	float x=X.GetXDistance(),y=X.GetYDistance();
	Y.SetXDistance(Y.GetXDistance()-x);
	Y.SetYDistance(Y.GetYDistance()-y);
	X.SetXDistance(0.0);
	X.SetYDistance(0.0);
	theta=atan2(Y.GetYDistance(),Y.GetXDistance());
	z.SetXDistance(X.GetXDistance()+2*cos(theta)+x);
	z.SetYDistance(X.GetYDistance()+2*sin(theta)+y);
	return z;
}

//Function to control the mouse in the CARROM window
int CARROMMouseClick(const Position &p){
	float x=p.GetXDistance(),y=p.GetYDistance();
	if(x>2.85*SIZE_FACTOR && x<8.8*SIZE_FACTOR && flag==0){//Setting the position of the striker
		Striker.Erase();
		if(turn%2==0){
			Striker.SetPosition(Position(p.GetXDistance(),2.4*SIZE_FACTOR));
			striker=Striker.GetPosition();
			//Restoring CARROM structure and displaying striker
			CARROM.RenderLine(Position(3.0*SIZE_FACTOR,2.5*SIZE_FACTOR),Position(9.0*SIZE_FACTOR,2.5*SIZE_FACTOR),Black,0.05);
			CARROM.RenderLine(Position(3.0*SIZE_FACTOR,2.9*SIZE_FACTOR),Position(9.0*SIZE_FACTOR,2.9*SIZE_FACTOR),Black,0.0);
			CircleShape G(CARROM,Position(2.7*SIZE_FACTOR,3.0*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
			G.Draw();
			CircleShape H(CARROM,Position(2.7*SIZE_FACTOR,3.01*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
			H.Draw();
			CircleShape K(CARROM,Position(9.3*SIZE_FACTOR,3.0*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
			K.Draw();
			CircleShape L(CARROM,Position(9.3*SIZE_FACTOR,3.01*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
			L.Draw();
			CircleShape O(CARROM,Position(3.0*SIZE_FACTOR,2.7*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
			O.Draw();
			CircleShape P(CARROM,Position(3.01*SIZE_FACTOR,2.7*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
			P.Draw();
			CircleShape Q(CARROM,Position(9.0*SIZE_FACTOR,2.7*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
			Q.Draw();
			CircleShape R(CARROM,Position(9.0*SIZE_FACTOR,2.7*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
			R.Draw();
			CARROM.RenderLine(Position(2.0*SIZE_FACTOR,2.0*SIZE_FACTOR),Position(4.0*SIZE_FACTOR,4.0*SIZE_FACTOR),Black,0.0);
			CARROM.RenderLine(Position(2.0*SIZE_FACTOR,10.0*SIZE_FACTOR),Position(4.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Black,0.0);
			Striker.Draw();
		}
		else{
			Striker.SetPosition(Position(p.GetXDistance(),9.0*SIZE_FACTOR));
			striker=Striker.GetPosition();
			//Restoring CARROM structure and displaying striker
			CARROM.RenderLine(Position(3.0*SIZE_FACTOR,9.5*SIZE_FACTOR),Position(9.0*SIZE_FACTOR,9.5*SIZE_FACTOR),Black,0.05);
			CARROM.RenderLine(Position(3.0*SIZE_FACTOR,9.1*SIZE_FACTOR),Position(9.0*SIZE_FACTOR,9.1*SIZE_FACTOR),Black,0.0);
			CircleShape I(CARROM,Position(2.7*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
			I.Draw();
			CircleShape J(CARROM,Position(2.7*SIZE_FACTOR,9.0*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
			J.Draw();
			CircleShape M(CARROM,Position(9.3*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
			M.Draw();
			CircleShape N(CARROM,Position(9.3*SIZE_FACTOR,9.0*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
			N.Draw();
			CircleShape S(CARROM,Position(3.0*SIZE_FACTOR,9.3*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
			S.Draw();
			CircleShape T(CARROM,Position(3.01*SIZE_FACTOR,9.3*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
			T.Draw();
			CircleShape U(CARROM,Position(9.0*SIZE_FACTOR,9.3*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
			U.Draw();
			CircleShape V(CARROM,Position(9.0*SIZE_FACTOR,9.3*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
			V.Draw();
			CARROM.RenderLine(Position(10.0*SIZE_FACTOR,10.0*SIZE_FACTOR),Position(8.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Black,0.0);
			CARROM.RenderLine(Position(8.0*SIZE_FACTOR,4.0*SIZE_FACTOR),Position(10.0*SIZE_FACTOR,2.0*SIZE_FACTOR),Black,0.0);
			Striker.Draw();
		}
		CARROM.SetMouseClickCallback(CARROMMouseClick);
	}
	else if(x<12.0*SIZE_FACTOR && flag==1){//Setting the angle
		Position r=striker;//Getting position of Striker
		r.SetXDistance(r.GetXDistance()+0.34);//Setting position as the center of the striker
		r.SetYDistance(r.GetYDistance()+0.34);//Same
		Position s=calculate_end_point(r,p);
		//Restoring structure of CARROM and drawing the angle line
		if(turn%2==0){
			CARROM.RenderRectangle(Position(1.0*SIZE_FACTOR,1.0*SIZE_FACTOR),Position(11.0*SIZE_FACTOR,4.45*SIZE_FACTOR),White);
			CircleShape C(CARROM,Position(1.3*SIZE_FACTOR,1.3*SIZE_FACTOR),Black,0.6*SIZE_FACTOR);
			C.Draw();
			CircleShape E(CARROM,Position(10.7*SIZE_FACTOR,1.3*SIZE_FACTOR),Black,0.6*SIZE_FACTOR);
			E.Draw();
			CARROM.RenderLine(Position(2.5*SIZE_FACTOR,3.0*SIZE_FACTOR),Position(2.5*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.05);
			CARROM.RenderLine(Position(2.9*SIZE_FACTOR,3.0*SIZE_FACTOR),Position(2.9*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.0);
			CARROM.RenderLine(Position(9.5*SIZE_FACTOR,3.0*SIZE_FACTOR),Position(9.5*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.05);
			CARROM.RenderLine(Position(9.1*SIZE_FACTOR,3.0*SIZE_FACTOR),Position(9.1*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.0);
			CARROM.RenderLine(Position(3.0*SIZE_FACTOR,2.5*SIZE_FACTOR),Position(9.0*SIZE_FACTOR,2.5*SIZE_FACTOR),Black,0.05);
			CARROM.RenderLine(Position(3.0*SIZE_FACTOR,2.9*SIZE_FACTOR),Position(9.0*SIZE_FACTOR,2.9*SIZE_FACTOR),Black,0.0);
			CircleShape G(CARROM,Position(2.7*SIZE_FACTOR,3.0*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
			G.Draw();
			CircleShape H(CARROM,Position(2.7*SIZE_FACTOR,3.01*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
			H.Draw();
			CircleShape K(CARROM,Position(9.3*SIZE_FACTOR,3.0*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
			K.Draw();
			CircleShape L(CARROM,Position(9.3*SIZE_FACTOR,3.01*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
			L.Draw();
			CircleShape O(CARROM,Position(3.0*SIZE_FACTOR,2.7*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
			O.Draw();
			CircleShape P(CARROM,Position(3.01*SIZE_FACTOR,2.7*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
			P.Draw();
			CircleShape Q(CARROM,Position(9.0*SIZE_FACTOR,2.7*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
			Q.Draw();
			CircleShape R(CARROM,Position(9.0*SIZE_FACTOR,2.7*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
			R.Draw();
			CARROM.RenderLine(Position(2.0*SIZE_FACTOR,2.0*SIZE_FACTOR),Position(4.0*SIZE_FACTOR,4.0*SIZE_FACTOR),Black,0.0);
			CARROM.RenderLine(Position(8.0*SIZE_FACTOR,4.0*SIZE_FACTOR),Position(10.0*SIZE_FACTOR,2.0*SIZE_FACTOR),Black,0.0);
			CARROM.RenderLine(Position(4.0*SIZE_FACTOR,4.0*SIZE_FACTOR),Position(3.8*SIZE_FACTOR,3.6*SIZE_FACTOR),Black,0.0);
			CARROM.RenderLine(Position(4.0*SIZE_FACTOR,4.0*SIZE_FACTOR),Position(3.6*SIZE_FACTOR,3.8*SIZE_FACTOR),Black,0.0);
			CARROM.RenderLine(Position(8.0*SIZE_FACTOR,4.0*SIZE_FACTOR),Position(8.2*SIZE_FACTOR,3.6*SIZE_FACTOR),Black,0.0);
			CARROM.RenderLine(Position(8.0*SIZE_FACTOR,4.0*SIZE_FACTOR),Position(8.4*SIZE_FACTOR,3.8*SIZE_FACTOR),Black,0.0);
			Striker.SetPosition(striker);
			Striker.Draw();
		}
		else{
			CARROM.RenderRectangle(Position(1.0*SIZE_FACTOR,7.55*SIZE_FACTOR),Position(11.0*SIZE_FACTOR,11.0*SIZE_FACTOR),White);
			CircleShape D(CARROM,Position(1.3*SIZE_FACTOR,10.7*SIZE_FACTOR),Black,0.6*SIZE_FACTOR);
			D.Draw();
			CircleShape F(CARROM,Position(10.7*SIZE_FACTOR,10.7*SIZE_FACTOR),Black,0.6*SIZE_FACTOR);
			F.Draw();
			CARROM.RenderLine(Position(2.5*SIZE_FACTOR,3.0*SIZE_FACTOR),Position(2.5*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.05);
			CARROM.RenderLine(Position(2.9*SIZE_FACTOR,3.0*SIZE_FACTOR),Position(2.9*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.0);
			CARROM.RenderLine(Position(9.5*SIZE_FACTOR,3.0*SIZE_FACTOR),Position(9.5*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.05);
			CARROM.RenderLine(Position(9.1*SIZE_FACTOR,3.0*SIZE_FACTOR),Position(9.1*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.0);
			CARROM.RenderLine(Position(3.0*SIZE_FACTOR,9.5*SIZE_FACTOR),Position(9.0*SIZE_FACTOR,9.5*SIZE_FACTOR),Black,0.05);
			CARROM.RenderLine(Position(3.0*SIZE_FACTOR,9.1*SIZE_FACTOR),Position(9.0*SIZE_FACTOR,9.1*SIZE_FACTOR),Black,0.0);
			CircleShape I(CARROM,Position(2.7*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
			I.Draw();
			CircleShape J(CARROM,Position(2.7*SIZE_FACTOR,9.0*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
			J.Draw();
			CircleShape M(CARROM,Position(9.3*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
			M.Draw();
			CircleShape N(CARROM,Position(9.3*SIZE_FACTOR,9.0*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
			N.Draw();
			CircleShape S(CARROM,Position(3.0*SIZE_FACTOR,9.3*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
			S.Draw();
			CircleShape T(CARROM,Position(3.01*SIZE_FACTOR,9.3*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
			T.Draw();
			CircleShape U(CARROM,Position(9.0*SIZE_FACTOR,9.3*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
			U.Draw();
			CircleShape V(CARROM,Position(9.0*SIZE_FACTOR,9.3*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
			V.Draw();
			CARROM.RenderLine(Position(10.0*SIZE_FACTOR,10.0*SIZE_FACTOR),Position(8.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Black,0.0);
			CARROM.RenderLine(Position(2.0*SIZE_FACTOR,10.0*SIZE_FACTOR),Position(4.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Black,0.0);
			CARROM.RenderLine(Position(4.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Position(3.6*SIZE_FACTOR,8.2*SIZE_FACTOR),Black,0.0);
			CARROM.RenderLine(Position(4.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Position(3.8*SIZE_FACTOR,8.4*SIZE_FACTOR),Black,0.0);
			CARROM.RenderLine(Position(8.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Position(8.2*SIZE_FACTOR,8.4*SIZE_FACTOR),Black,0.0);
			CARROM.RenderLine(Position(8.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Position(8.4*SIZE_FACTOR,8.2*SIZE_FACTOR),Black,0.0);
			Striker.SetPosition(striker);
			Striker.Draw();
		}
		CARROM.RenderLine(r,s,Black,0.1);
		CARROM.SetMouseClickCallback(CARROMMouseClick);
	}
	else if(x>13.0*SIZE_FACTOR && x<14.0*SIZE_FACTOR && y>3.0*SIZE_FACTOR && y<8.0*SIZE_FACTOR && flag==2){//Setting the power
		CARROM.RenderRectangle(Position(13.0*SIZE_FACTOR,3.0*SIZE_FACTOR),Position(14.0*SIZE_FACTOR,8.0*SIZE_FACTOR),White);
		CARROM.RenderRectangle(Position(13.0*SIZE_FACTOR,p.GetYDistance()),Position(14.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Red);
		power=8.0*SIZE_FACTOR-p.GetYDistance();
		CARROM.SetMouseClickCallback(CARROMMouseClick);
	}
	else if(x>12.0*SIZE_FACTOR && x<15.0*SIZE_FACTOR && y>11.0*SIZE_FACTOR && y<12.0*SIZE_FACTOR && flag==3){
		//Shoot();
		turn++;
		Striker.Erase();
		flag=0;
		CARROM.RenderRectangle(Position(13.0*SIZE_FACTOR,3.0*SIZE_FACTOR),Position(14.0*SIZE_FACTOR,8.0*SIZE_FACTOR),White);
		CARROM.RenderText(Position(13.0*SIZE_FACTOR,11.0*SIZE_FACTOR),Position(14.0*SIZE_FACTOR,12.0*SIZE_FACTOR),"POSITION SET",Red,Black);
		if(turn%2==0){
			Striker.SetPosition(Position(5.7*SIZE_FACTOR,2.4*SIZE_FACTOR));
			Striker.Draw();
			striker=Striker.GetPosition();
		}
		else{
			Striker.SetPosition(Position(5.7*SIZE_FACTOR,9.0*SIZE_FACTOR));
			Striker.Draw();
			striker=Striker.GetPosition();
		}
		CARROM.SetMouseClickCallback(CARROMMouseClick);
	}
	else if(x>12.0*SIZE_FACTOR && x<15.0*SIZE_FACTOR && y>11.0*SIZE_FACTOR && y<12.0*SIZE_FACTOR && flag==0){
		CARROM.RenderRectangle(Position(12.0*SIZE_FACTOR,11.0*SIZE_FACTOR),Position(15.0*SIZE_FACTOR,12.0*SIZE_FACTOR),Black);
		CARROM.RenderText(Position(13.0*SIZE_FACTOR,11.0*SIZE_FACTOR),Position(14.0*SIZE_FACTOR,12.0*SIZE_FACTOR),"ANGLE SET",Red,Black);
		flag++;
		if(turn%2==0)
			CARROM.RenderLine(Position(striker.GetXDistance()+0.34,striker.GetYDistance()+0.34),Position(striker.GetXDistance()+0.34,4.0*SIZE_FACTOR),Black,0.1);
		else
			CARROM.RenderLine(Position(striker.GetXDistance()+0.34,striker.GetYDistance()+0.34),Position(striker.GetXDistance()+0.34,8.0*SIZE_FACTOR),Black,0.1);
		CARROM.SetMouseClickCallback(CARROMMouseClick);
	}
	else if(x>12.0*SIZE_FACTOR && x<15.0*SIZE_FACTOR && y>11.0*SIZE_FACTOR && y<12.0*SIZE_FACTOR && flag==1){
		CARROM.RenderRectangle(Position(12.0*SIZE_FACTOR,11.0*SIZE_FACTOR),Position(15.0*SIZE_FACTOR,12.0*SIZE_FACTOR),Black);
		CARROM.RenderText(Position(13.0*SIZE_FACTOR,11.0*SIZE_FACTOR),Position(14.0*SIZE_FACTOR,12.0*SIZE_FACTOR),"POWER SET",Red,Black);
		flag++;
		CARROM.SetMouseClickCallback(CARROMMouseClick);
	}
	else if(x>12.0*SIZE_FACTOR && x<15.0*SIZE_FACTOR && y>11.0*SIZE_FACTOR && y<12.0*SIZE_FACTOR && flag==2){
		CARROM.RenderRectangle(Position(12.0*SIZE_FACTOR,11.0*SIZE_FACTOR),Position(15.0*SIZE_FACTOR,12.0*SIZE_FACTOR),Black);
		CARROM.RenderText(Position(13.0*SIZE_FACTOR,11.0*SIZE_FACTOR),Position(14.0*SIZE_FACTOR,12.0*SIZE_FACTOR),"SHOOT!",Red,Black);
		flag++;
		CARROM.SetMouseClickCallback(CARROMMouseClick);
	}
	else CARROM.SetMouseClickCallback(CARROMMouseClick);
}

//Function to open the Welcome screen and display the contents of the window.
int Open_Welcome_Screen(){
	WelcomeScreen.Open();
	assert(WelcomeScreen.GetStatus()==WindowOpen);

	//Background and main titles

	WelcomeScreen.RenderRectangle(Position(0.0,0.0),Position(20.0,14.0),White);

	//Main title "CARROM-171"
	WelcomeScreen.RenderRectangle(Position(0.0,0.0),Position(20.0,4.0),Blue);
	CircleShape a(WelcomeScreen,Position(2.5,2.0),White,4.0);
	a.Draw();
	WelcomeScreen.RenderRectangle(Position(2.5,0.0),Position(4.5,4.0),Blue);
	CircleShape f(WelcomeScreen,Position(2.5,2.0),Blue,3.75);
	f.Draw();
	WelcomeScreen.RenderRectangle(Position(2.5,0.0),Position(4.5,4.0),Blue);
	EllipseShape b(WelcomeScreen,Position(8.0,1.0),White,4.0,2.0);
	b.Draw();
	EllipseShape g(WelcomeScreen,Position(8.0,1.0),Blue,3.75,1.75);
	g.Draw();
	WelcomeScreen.RenderRectangle(Position(6.0,0.0),Position(8.0,4.0),Blue);
	EllipseShape c(WelcomeScreen,Position(5.5,1.0),White,4.0,2.0);
	c.Draw();
	EllipseShape h(WelcomeScreen,Position(5.5,1.0),Blue,3.75,1.75);
	h.Draw();
	WelcomeScreen.RenderRectangle(Position(3.5,0.0),Position(5.5,4.0),Blue);
	WelcomeScreen.RenderLine(Position(4.0,0.0),Position(3.0,4.0),White,0.1);
	WelcomeScreen.RenderLine(Position(4.0,0.0),Position(5.0,4.0),White,0.1);
	WelcomeScreen.RenderLine(Position(3.25,2.5),Position(4.75,2.5),White,0.1);
	WelcomeScreen.RenderLine(Position(5.5,0.0),Position(5.5,4.0),White,0.1);
	WelcomeScreen.RenderLine(Position(5.5,2.0),Position(7.5,4.0),White,0.1);
	WelcomeScreen.RenderLine(Position(8.0,0.0),Position(8.0,4.0),White,0.1);
	WelcomeScreen.RenderLine(Position(8.0,2.0),Position(10.0,4.0),White,0.1);
	EllipseShape d(WelcomeScreen,Position(11.75,2.0),White,2.5,4.0);
	d.Draw();
	EllipseShape e(WelcomeScreen,Position(11.75,2.0),Blue,2.25,3.75);
	e.Draw();
	WelcomeScreen.RenderLine(Position(13.5,0.0),Position(13.5,4.0),White,0.1);
	WelcomeScreen.RenderLine(Position(15.5,0.0),Position(15.5,4.0),White,0.1);
	WelcomeScreen.RenderLine(Position(15.5,0.0),Position(14.5,2.0),White,0.1);
	WelcomeScreen.RenderLine(Position(13.5,0.0),Position(14.5,2.0),White,0.1);
	WelcomeScreen.RenderLine(Position(16.0,2.0),Position(16.5,2.0),White,0.1);
	WelcomeScreen.RenderLine(Position(17.0,0.0),Position(17.0,4.0),White,0.1);
	WelcomeScreen.RenderLine(Position(17.0,0.0),Position(16.5,1.0),White,0.1);
	WelcomeScreen.RenderLine(Position(16.75,4.0),Position(17.25,4.0),White,0.1);
	WelcomeScreen.RenderLine(Position(17.75,0.05),Position(18.75,0.05),White,0.1);
	WelcomeScreen.RenderLine(Position(18.75,0.0),Position(18.0,4.0),White,0.1);
	WelcomeScreen.RenderLine(Position(19.5,0.0),Position(19.5,4.0),White,0.1);
	WelcomeScreen.RenderLine(Position(19.5,0.0),Position(19.0,1.0),White,0.1);
	WelcomeScreen.RenderLine(Position(19.25,4.0),Position(19.75,4.0),White,0.1);

	//Other 4 options, START GAME, HOW TO PLAY, CREDITS, EXIT

	WelcomeScreen.RenderText(Position(6.0,4.5),Position(14.0,6.5),"START GAME",White,Blue);
	WelcomeScreen.RenderText(Position(6.0,6.5),Position(14.0,8.5),"HOW TO PLAY",White,Blue);
	WelcomeScreen.RenderText(Position(6.0,8.5),Position(14.0,10.5),"CREDITS",White,Blue);
	WelcomeScreen.RenderText(Position(6.0,10.5),Position(14.0,12.5),"EXIT GAME",White,Blue);
	WelcomeScreen.RenderText(Position(5.0,12.5),Position(15.0,14.0),"CLICK ON THE OPTION YOU WISH TO SELECT TO PROCEED.",White,Blue);
	
	WelcomeScreen.SetMouseClickCallback(WelcomeScreenMouseClick);
	return 1;
}

//Function to control the mouse in the credits window
int CreditsMouseClick(const Position &p){
	float x=p.GetXDistance(),y=p.GetYDistance();
	if(x>12.4 && x<16.4 && y<14.0 && y>13.5){
		Credits.Close();
		Open_Welcome_Screen();
		return 1;
	}
	else{
		Credits.SetMouseClickCallback(CreditsMouseClick);
	}
}

//Funtion to control the mouse in the How_to_play window
int How_to_playMouseClick(const Position &p){
	float x=p.GetXDistance(),y=p.GetYDistance();
	if(x>11.0 && x<15.0 && y<14.0 && y>13.5){
		How_to_play.Close();
		Open_Welcome_Screen();
		return 1;
	}
	else{
		How_to_play.SetMouseClickCallback(How_to_playMouseClick);
	}
}

//Funtion to control the mouse in the WelcomeScreen window
int WelcomeScreenMouseClick(const Position &p){
	float x=p.GetXDistance(),y=p.GetYDistance();
	if(x<14.0 && x>6.0 && y>8.5 && y<10.5){
		WelcomeScreen.Close();
		Credits.Open();
		assert(Credits.GetStatus()==WindowOpen);

		//Background and details

		Credits.RenderRectangle(Position(0.0,0.0),Position(16.6,14.0),Black);

		//Top title "TEAM-171"

		Credits.RenderLine(Position(1.0,0.05),Position(3.0,0.05),Cyan,0.1);
		Credits.RenderLine(Position(2.0,0.0),Position(2.0,4.0),Cyan,0.1);
		Credits.RenderLine(Position(3.5,0.0),Position(3.5,4.0),Cyan,0.1);
		Credits.RenderLine(Position(3.5,0.05),Position(5.5,0.05),Cyan,0.1);
		Credits.RenderLine(Position(3.5,2.0),Position(4.5,2.0),Cyan,0.1);
		Credits.RenderLine(Position(3.5,4.0),Position(5.5,4.0),Cyan,0.1);
		Credits.RenderLine(Position(7.0,0.0),Position(6.0,4.0),Cyan,0.1);
		Credits.RenderLine(Position(7.0,0.0),Position(8.0,4.0),Cyan,0.1);
		Credits.RenderLine(Position(6.25,2.75),Position(7.75,2.75),Cyan,0.1);
		Credits.RenderLine(Position(8.5,0.0),Position(8.5,4.0),Cyan,0.1);
		Credits.RenderLine(Position(10.5,0.0),Position(10.5,4.0),Cyan,0.1);
		Credits.RenderLine(Position(10.5,0.0),Position(9.5,2.0),Cyan,0.1);
		Credits.RenderLine(Position(8.5,0.0),Position(9.5,2.0),Cyan,0.1);
		Credits.RenderLine(Position(11.0,2.0),Position(12.0,2.0),Cyan,0.1);
		Credits.RenderLine(Position(12.5,0.0),Position(12.5,4.0),Cyan,0.1);
		Credits.RenderLine(Position(12.5,0.0),Position(12.0,1.0),Cyan,0.1);
		Credits.RenderLine(Position(12.125,4.0),Position(12.875,4.0),Cyan,0.1);
		Credits.RenderLine(Position(13.0,0.05),Position(14.5,0.05),Cyan,0.1);
		Credits.RenderLine(Position(14.5,0.0),Position(13.25,4.0),Cyan,0.1);
		Credits.RenderLine(Position(15.25,0.0),Position(15.25,4.0),Cyan,0.1);
		Credits.RenderLine(Position(15.25,0.0),Position(14.75,1.0),Cyan,0.1);
		Credits.RenderLine(Position(14.875,4.0),Position(15.575,4.0),Cyan,0.1);

		//Team members

		Credits.RenderText(Position(5.3,4.5),Position(11.3,5.5),"TOSHENDRA SHARMA (T.A. AND MENTOR)",Cyan,Black);
		Credits.RenderText(Position(5.3,5.5),Position(11.3,6.5),"TEJAS SONI (TEAM LEADER)",Cyan,Black);
		Credits.RenderText(Position(5.3,6.5),Position(11.3,7.5),"VAMSIDHAR Y.",Cyan,Black);
		Credits.RenderText(Position(5.3,7.5),Position(11.3,8.5),"VIVAN SORAB",Cyan,Black);
		Credits.RenderText(Position(5.3,8.5),Position(11.3,9.5),"TARKESHWAR SINGH",Cyan,Black);
		Credits.RenderText(Position(5.3,9.5),Position(11.3,10.5),"SURESH CHAND MEENA",Cyan,Black);
		Credits.RenderText(Position(5.3,10.5),Position(11.3,11.5),"SUNNY KATARIA",Cyan,Black);
		Credits.RenderText(Position(5.3,11.5),Position(11.3,12.5),"SAI KRISHNA R.",Cyan,Black);
		Credits.RenderText(Position(5.3,12.5),Position(11.3,13.5),"VIPUL SNEHI",Cyan,Black);
		Credits.RenderText(Position(12.4,13.5),Position(16.4,14.0),"CLICK HERE TO GO BACK",Cyan,Black);
		Credits.SetMouseClickCallback(CreditsMouseClick);
	}
	else if(x>6.0 && x<14.0 && y>6.5 && y<8.5){
		WelcomeScreen.Close();
		How_to_play.Open();
		assert(How_to_play.GetStatus()==WindowOpen);

		//Background and the details

		How_to_play.RenderRectangle(Position(0.0,0.0),Position(16.0,14.0),Black);
		How_to_play.RenderText(Position(1.0,0.0),Position(15.0,1.0),"..::RULES OF THE GAME::..",Red,Black);
		How_to_play.RenderText(Position(1.0,1.0),Position(15.0,1.5),"The game is similar to the original game. The game was introduced in",Red,Black);
		How_to_play.RenderText(Position(1.0,1.5),Position(15.0,2.0),"India. This game is designed for two players. Both players get alternate",Red,Black);
		How_to_play.RenderText(Position(1.0,2.0),Position(15.0,2.5),"turns to shoot. The striker is used to shoot other pieces on the board.",Red,Black);
		How_to_play.RenderText(Position(1.0,2.5),Position(15.0,3.0),"The striker has to be placed between the base lines. There are 16 pieces,",Red,Black);
		How_to_play.RenderText(Position(1.0,3.0),Position(15.0,3.5),"four of each of the following colors: Cyan, Blue, Green and Black.",Red,Black);
		How_to_play.RenderText(Position(1.0,3.5),Position(15.0,4.0),"Each color has an associated value to it:",Red,Black);
		How_to_play.RenderText(Position(1.0,4.0),Position(15.0,4.5),"Cyan - 50 points",Red,Black);
		How_to_play.RenderText(Position(1.0,4.5),Position(15.0,5.0),"Blue - 40 points",Red,Black);
		How_to_play.RenderText(Position(1.0,5.0),Position(15.0,5.5),"Green - 25 points",Red,Black);
		How_to_play.RenderText(Position(1.0,5.5),Position(15.0,6.0),"Black - 10 points",Red,Black);
		How_to_play.RenderText(Position(1.0,6.0),Position(15.0,6.5),"All colors are open to both players and they score points corresponding",Red,Black);
		How_to_play.RenderText(Position(1.0,6.5),Position(15.0,7.0),"to the color of the piece they sink in any of the four pockets at the",Red,Black);
		How_to_play.RenderText(Position(1.0,7.0),Position(15.0,7.5),"corners. For sinking the striker a penalty of 10 points is given. At",Red,Black);
		How_to_play.RenderText(Position(1.0,7.5),Position(15.0,8.0),"the end of the game, the person with more points wins.",Red,Black);
		How_to_play.RenderText(Position(1.0,8.0),Position(15.0,9.0),"..::HOW TO PLAY::..",Red,Black);
		How_to_play.RenderText(Position(1.0,9.0),Position(15.0,9.5),"The first step is to set the position of the striker. Using the mouse,",Red,Black);
		How_to_play.RenderText(Position(1.0,9.5),Position(15.0,10.0),"click on the position between the base lines where you want the striker",Red,Black);
		How_to_play.RenderText(Position(1.0,10.0),Position(15.0,10.5),"to be placed. Once you select the position, confirm it by clicking on",Red,Black);
		How_to_play.RenderText(Position(1.0,10.5),Position(15.0,11.0),"POSITION SET at the bottom-right of the board. Next, select the",Red,Black);
		How_to_play.RenderText(Position(1.0,11.0),Position(15.0,11.5),"direction in which you want to shoot the striker by clicking in the",Red,Black);
		How_to_play.RenderText(Position(1.0,11.5),Position(15.0,12.0),"direction. Once you select the angle, confirm it by clicking on ANGLE",Red,Black);
		How_to_play.RenderText(Position(1.0,12.0),Position(15.0,12.5),"SET. Next, select the power with which you want to shoot the striker",Red,Black);
		How_to_play.RenderText(Position(1.0,12.5),Position(15.0,13.0),"by clicking in the power bar at the appropriate level. Once done,",Red,Black);
		How_to_play.RenderText(Position(1.0,13.0),Position(15.0,13.5),"click on POWER SET and then click on SHOOT! to make your shot. Enjoy!",Red,Black);
		How_to_play.RenderText(Position(11.0,13.5),Position(15.0,14.0),"CLICK HERE TO GO BACK",Red,Black);
		How_to_play.SetMouseClickCallback(How_to_playMouseClick);
	}
	else if(x>6.0 && x<14.0 && y>10.5 && y<12.5){
		WelcomeScreen.Close();
		exit(0);
	}
	else if(x>6.0 && x<14.0 && y>4.5 && y<6.5){
		WelcomeScreen.Close();
		CARROM.Open();
		assert(CARROM.GetStatus()==WindowOpen);
		display_carrom_background();		
		//For striker and pieces
		Striker.Load("Striker.xpm");
		Striker.SetPosition(Position(5.7*SIZE_FACTOR,2.4*SIZE_FACTOR));
		Striker.Draw();
		striker=Striker.GetPosition();
		Cyan1.Load("Cyan.xpm");
		Cyan1.SetPosition(Position(4.7*SIZE_FACTOR,4.7*SIZE_FACTOR));
		Cyan1.Draw();
		cyan1=Cyan1.GetPosition();
		Cyan2.Load("Cyan.xpm");
		Cyan2.SetPosition(Position(5.45*SIZE_FACTOR,5.45*SIZE_FACTOR));
		Cyan2.Draw();
		cyan2=Cyan2.GetPosition();
		Cyan3.Load("Cyan.xpm");
		Cyan3.SetPosition(Position(6.95*SIZE_FACTOR,6.95*SIZE_FACTOR));
		Cyan3.Draw();
		cyan3=Cyan3.GetPosition();
		Cyan4.Load("Cyan.xpm");
		Cyan4.SetPosition(Position(6.2*SIZE_FACTOR,6.2*SIZE_FACTOR));
		Cyan4.Draw();
		cyan4=Cyan4.GetPosition();
		Green1.Load("Green.xpm");
		Green1.SetPosition(Position(4.7*SIZE_FACTOR,6.2*SIZE_FACTOR));
		Green1.Draw();
		green1=Green1.GetPosition();
		Green2.Load("Green.xpm");
		Green2.SetPosition(Position(5.45*SIZE_FACTOR,6.95*SIZE_FACTOR));
		Green2.Draw();
		green2=Green2.GetPosition();
		Green3.Load("Green.xpm");
		Green3.SetPosition(Position(6.2*SIZE_FACTOR,4.7*SIZE_FACTOR));
		Green3.Draw();
		green3=Green3.GetPosition();
		Green4.Load("Green.xpm");
		Green4.SetPosition(Position(6.95*SIZE_FACTOR,5.45*SIZE_FACTOR));
		Green4.Draw();
		green4=Green4.GetPosition();
		Blue1.Load("Blue.xpm");
		Blue1.SetPosition(Position(4.7*SIZE_FACTOR,5.45*SIZE_FACTOR));
		Blue1.Draw();
		blue1=Blue1.GetPosition();
		Blue2.Load("Blue.xpm");
		Blue2.SetPosition(Position(5.45*SIZE_FACTOR,6.2*SIZE_FACTOR));
		Blue2.Draw();
		blue2=Blue2.GetPosition();
		Blue3.Load("Blue.xpm");
		Blue3.SetPosition(Position(6.2*SIZE_FACTOR,6.95*SIZE_FACTOR));
		Blue3.Draw();
		blue3=Blue3.GetPosition();
		Blue4.Load("Blue.xpm");
		Blue4.SetPosition(Position(6.95*SIZE_FACTOR,4.7*SIZE_FACTOR));
		Blue4.Draw();
		blue4=Blue4.GetPosition();
		Black1.Load("Black.xpm");
		Black1.SetPosition(Position(4.7*SIZE_FACTOR,6.95*SIZE_FACTOR));
		Black1.Draw();
		black1=Black1.GetPosition();
		Black2.Load("Black.xpm");
		Black2.SetPosition(Position(5.45*SIZE_FACTOR,4.7*SIZE_FACTOR));
		Black2.Draw();
		black2=Black2.GetPosition();
		Black3.Load("Black.xpm");
		Black3.SetPosition(Position(6.2*SIZE_FACTOR,5.45*SIZE_FACTOR));
		Black3.Draw();
		black3=Black3.GetPosition();
		Black4.Load("Black.xpm");
		Black4.SetPosition(Position(6.95*SIZE_FACTOR,6.2*SIZE_FACTOR));
		Black4.Draw();
		black4=Black4.GetPosition();

		CARROM.SetMouseClickCallback(CARROMMouseClick);		
	}
	else{
		WelcomeScreen.SetMouseClickCallback(WelcomeScreenMouseClick);
	}
}

//Main function starts here
	
int ApiMain(){
	char player[20];
	cout<<"Please enter the name of Player 1 and 2."<<endl;
	cout<<"Player 1: ";
	gets(player);
	Player_1.set_name(player);
	cout<<"Player 2: ";
	gets(player);
	Player_2.set_name(player);
	Open_Welcome_Screen();
	return 0;
}//Main function ends
