#ifndef WELCOMESCREEN_H_INCLUDED
#define WELCOMESCREEN_H_INCLUDED
#include"Credits.h"
#include"How_to_play.h"
#include"CARROM.h"
SimpleWindow WelcomeScreen("Welcome",20.0,14.0);//Defining the WelcomeScreen window

int Open_Welcome_Screen();//Function to open the WelcomeScreen window
int WelcomeScreenMouseClick(const Position &p);//Function to manage the mouse clicks in the WelcomeScreen window
BitMap carrom(WelcomeScreen);//To display carrom image
BitMap the_war(WelcomeScreen);

//Function to open the Welcome screen and display the contents of the window.
int Open_Welcome_Screen(){
	WelcomeScreen.Open();
	assert(WelcomeScreen.GetStatus()==WindowOpen);

	//Background and main titles

	WelcomeScreen.RenderRectangle(Position(0.0,0.0),Position(20.0,14.0),White);

	//Main title "CARROM-171"
	WelcomeScreen.RenderRectangle(Position(0.0,0.0),Position(20.0,4.0),Blue);
	CircleShape a(WelcomeScreen,Position(2.5,2.0),White,4.0);
	a.Draw();
	WelcomeScreen.RenderRectangle(Position(2.5,0.0),Position(4.5,4.0),Blue);
	CircleShape f(WelcomeScreen,Position(2.5,2.0),Blue,3.75);
	f.Draw();
	WelcomeScreen.RenderRectangle(Position(2.5,0.0),Position(4.5,4.0),Blue);
	EllipseShape b(WelcomeScreen,Position(8.0,1.0),White,4.0,2.0);
	b.Draw();
	EllipseShape g(WelcomeScreen,Position(8.0,1.0),Blue,3.75,1.75);
	g.Draw();
	WelcomeScreen.RenderRectangle(Position(6.0,0.0),Position(8.0,4.0),Blue);
	EllipseShape c(WelcomeScreen,Position(5.5,1.0),White,4.0,2.0);
	c.Draw();
	EllipseShape h(WelcomeScreen,Position(5.5,1.0),Blue,3.75,1.75);
	h.Draw();
	WelcomeScreen.RenderRectangle(Position(3.5,0.0),Position(5.5,4.0),Blue);
	WelcomeScreen.RenderLine(Position(4.0,0.0),Position(3.0,4.0),White,0.1);
	WelcomeScreen.RenderLine(Position(4.0,0.0),Position(5.0,4.0),White,0.1);
	WelcomeScreen.RenderLine(Position(3.25,2.5),Position(4.75,2.5),White,0.1);
	WelcomeScreen.RenderLine(Position(5.5,0.0),Position(5.5,4.0),White,0.1);
	WelcomeScreen.RenderLine(Position(5.5,2.0),Position(7.5,4.0),White,0.1);
	WelcomeScreen.RenderLine(Position(8.0,0.0),Position(8.0,4.0),White,0.1);
	WelcomeScreen.RenderLine(Position(8.0,2.0),Position(10.0,4.0),White,0.1);
	EllipseShape d(WelcomeScreen,Position(11.75,2.0),White,2.5,4.0);
	d.Draw();
	EllipseShape e(WelcomeScreen,Position(11.75,2.0),Blue,2.25,3.75);
	e.Draw();
	WelcomeScreen.RenderLine(Position(13.5,0.0),Position(13.5,4.0),White,0.1);
	WelcomeScreen.RenderLine(Position(15.5,0.0),Position(15.5,4.0),White,0.1);
	WelcomeScreen.RenderLine(Position(15.5,0.0),Position(14.5,2.0),White,0.1);
	WelcomeScreen.RenderLine(Position(13.5,0.0),Position(14.5,2.0),White,0.1);
	WelcomeScreen.RenderLine(Position(16.0,2.0),Position(16.5,2.0),White,0.1);
	WelcomeScreen.RenderLine(Position(17.0,0.0),Position(17.0,4.0),White,0.1);
	WelcomeScreen.RenderLine(Position(17.0,0.0),Position(16.5,1.0),White,0.1);
	WelcomeScreen.RenderLine(Position(16.75,4.0),Position(17.25,4.0),White,0.1);
	WelcomeScreen.RenderLine(Position(17.75,0.05),Position(18.75,0.05),White,0.1);
	WelcomeScreen.RenderLine(Position(18.75,0.0),Position(18.0,4.0),White,0.1);
	WelcomeScreen.RenderLine(Position(19.5,0.0),Position(19.5,4.0),White,0.1);
	WelcomeScreen.RenderLine(Position(19.5,0.0),Position(19.0,1.0),White,0.1);
	WelcomeScreen.RenderLine(Position(19.25,4.0),Position(19.75,4.0),White,0.1);
	//Other 4 options, START GAME, HOW TO PLAY, CREDITS, EXIT

	WelcomeScreen.RenderText(Position(6.0,4.5),Position(14.0,6.5),"START GAME",White,Blue);
	WelcomeScreen.RenderText(Position(6.0,6.5),Position(14.0,8.5),"HOW TO PLAY",White,Blue);
	WelcomeScreen.RenderText(Position(6.0,8.5),Position(14.0,10.5),"CREDITS",White,Blue);
	WelcomeScreen.RenderText(Position(6.0,10.5),Position(14.0,12.5),"EXIT GAME",White,Blue);
	WelcomeScreen.RenderText(Position(5.0,12.5),Position(15.0,14.0),"CLICK ON THE OPTION YOU WISH TO SELECT TO PROCEED.",White,Blue);
    WelcomeScreen.SetMouseClickCallback(WelcomeScreenMouseClick);
    return 1;
//Funtion to control the mouse in the WelcomeScreen window
int WelcomeScreenMouseClick(const Position &p){
	float x=p.GetXDistance(),y=p.GetYDistance();
	if(x<14.0 && x>6.0 && y>8.5 && y<10.5){
		WelcomeScreen.Close();
		Open_Credits_Screen();
	}
	else if(x>6.0 && x<14.0 && y>6.5 && y<8.5){
		WelcomeScreen.Close();
		Open_How_to_play_screen();
	}
	else if(x>6.0 && x<14.0 && y>10.5 && y<12.5){
		WelcomeScreen.Close();
		exit(0);
	}
	else if(x>6.0 && x<14.0 && y>4.5 && y<6.5){
		WelcomeScreen.Close();
		Open_CARROM_screen();
	}
	else{
		WelcomeScreen.SetMouseClickCallback(WelcomeScreenMouseClick);
	}
}
#endif
