#include "ezwin.h"
#include <cassert>

// Create a window with title "Basic", size 10cm x 10cm,
//     positioned 3cm from left, 1cm from top of screen.
SimpleWindow MyWindow("Carroms", 10.0, 10.0,
              Position(3.0, 1.0));

// ApiMain(): create a window and display some shapes
int ApiMain() {
  MyWindow.Open();
  assert(MyWindow.GetStatus() == WindowOpen);

  // Colors: {White, Red, Green, Blue, Yellow, Cyan, Magenta};

  //Green Rectangle, with no border
  MyWindow.RenderRectangle(Position(1.0,1.0), Position(9.0,9.0),
               Yellow, false);

  //Yellow Rectangle, with border
  MyWindow.RenderRectangle(Position(2.5,2.5), Position(5.0,6.0),
               Yellow, true);

  //Blue Ellipse, border=true
  MyWindow.RenderEllipse( Position(1.0,6.5),Position(4.0, 8.5),
          Blue, true);
  //line1
  MyWindow.RenderLine(Position(0.0,0.0),Position(4.0,4.0),
              Red,0.0);

  //line2
  MyWindow.RenderLine(Position(10.0,0.0),Position(6.0,4.0),
              Red,0.0);

  //line3
  MyWindow.RenderLine(Position(0.0,10.0),Position(4.0,6.0),
              Red,0.0);

  //line4
  MyWindow.RenderLine(Position(10.0,10.0),Position(6.0,4.0),
              Red,0.0);

  return 0;
  } // end ApiMain()                                   
