#ifndef CARROM_H_INCLUDED
#define CARROM_H_INCLUDED
#define SIZE_FACTOR 1.2//Defining the size-factor for the carrom dimensions

SimpleWindow CARROM("Carrom", 15.0*SIZE_FACTOR, 12.0*SIZE_FACTOR);

Position striker,cyan1,cyan2,cyan3,cyan4,green1,green2,green3,green4,black1,black2,black3,black4,blue1,blue2,blue3,blue4,end_point;//For the position of the striker and the pieces
int flag=0,turn=0,balls_remaining=16,foul=0;//For miscellaneous uses, apparent from the variable name
float power=0.0;//To store the power which user selects
float striker_theta=100.0, cyan1_theta=100.0, cyan2_theta=100.0, cyan3_theta=100.0, cyan4_theta=100.0, blue1_theta=100.0, blue2_theta=100.0, blue3_theta=100.0, blue4_theta=100.0, green1_theta=100.0, green2_theta=100.0, green3_theta=100.0, green4_theta=100.0, black1_theta=100.0, black2_theta=100.0, black3_theta=100.0, black4_theta=100.0;//To store the slope/theta at which each piece moves
char player_score[15]="Score: ";

BitMap Striker(CARROM);
BitMap Cyan1(CARROM);
BitMap Cyan2(CARROM);
BitMap Cyan3(CARROM);
BitMap Cyan4(CARROM);
BitMap Green1(CARROM);
BitMap Green2(CARROM);
BitMap Green3(CARROM);
BitMap Green4(CARROM);
BitMap Blue1(CARROM);
BitMap Blue2(CARROM);
BitMap Blue3(CARROM);
BitMap Blue4(CARROM);
BitMap Black1(CARROM);
BitMap Black2(CARROM);
BitMap Black3(CARROM);
BitMap Black4(CARROM);

int CARROMMouseClick(const Position &p);//Function to control the mouse in the CARROM window
void Open_CARROM_screen();//Function to open the CARROM window initially
float calculate_theta(Position X,Position Y);//Function to calculate the slope of the line joining the two given points
void repair_carrom_background();//Function to show the repaired background of the carrom
void display_pieces();//Function to display the pieces
void Open_Display_Score_Screen();//Function to display the score after the game finishes
void Shoot();//Function to shoot the striker included in Shoot.h

//Function to control the mouse in the CARROM window
int CARROMMouseClick(const Position &p){
	float x=p.GetXDistance(),y=p.GetYDistance();
	if(x>2.85*SIZE_FACTOR && x<8.8*SIZE_FACTOR && flag==0){//Setting the position of the striker
		Striker.Erase();
		if(turn%2==0){
			Striker.SetPosition(Position(p.GetXDistance(),2.4*SIZE_FACTOR));
			striker=Striker.GetPosition();
			//Restoring CARROM structure and displaying striker
			CARROM.RenderLine(Position(3.0*SIZE_FACTOR,2.5*SIZE_FACTOR),Position(9.0*SIZE_FACTOR,2.5*SIZE_FACTOR),Black,0.05);
			CARROM.RenderLine(Position(3.0*SIZE_FACTOR,2.9*SIZE_FACTOR),Position(9.0*SIZE_FACTOR,2.9*SIZE_FACTOR),Black,0.0);
			CircleShape G(CARROM,Position(2.7*SIZE_FACTOR,3.0*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
			G.Draw();
			CircleShape H(CARROM,Position(2.7*SIZE_FACTOR,3.01*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
			H.Draw();
			CircleShape K(CARROM,Position(9.3*SIZE_FACTOR,3.0*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
			K.Draw();
			CircleShape L(CARROM,Position(9.3*SIZE_FACTOR,3.01*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
			L.Draw();
			CircleShape O(CARROM,Position(3.0*SIZE_FACTOR,2.7*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
			O.Draw();
			CircleShape P(CARROM,Position(3.01*SIZE_FACTOR,2.7*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
			P.Draw();
			CircleShape Q(CARROM,Position(9.0*SIZE_FACTOR,2.7*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
			Q.Draw();
			CircleShape R(CARROM,Position(9.0*SIZE_FACTOR,2.7*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
			R.Draw();
			CARROM.RenderLine(Position(2.0*SIZE_FACTOR,2.0*SIZE_FACTOR),Position(4.0*SIZE_FACTOR,4.0*SIZE_FACTOR),Black,0.0);
			CARROM.RenderLine(Position(2.0*SIZE_FACTOR,10.0*SIZE_FACTOR),Position(4.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Black,0.0);
			Striker.Draw();
		}
		else{
			Striker.SetPosition(Position(p.GetXDistance(),9.0*SIZE_FACTOR));
			striker=Striker.GetPosition();
			//Restoring CARROM structure and displaying striker
			CARROM.RenderLine(Position(3.0*SIZE_FACTOR,9.5*SIZE_FACTOR),Position(9.0*SIZE_FACTOR,9.5*SIZE_FACTOR),Black,0.05);
			CARROM.RenderLine(Position(3.0*SIZE_FACTOR,9.1*SIZE_FACTOR),Position(9.0*SIZE_FACTOR,9.1*SIZE_FACTOR),Black,0.0);
			CircleShape I(CARROM,Position(2.7*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
			I.Draw();
			CircleShape J(CARROM,Position(2.7*SIZE_FACTOR,9.0*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
			J.Draw();
			CircleShape M(CARROM,Position(9.3*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
			M.Draw();
			CircleShape N(CARROM,Position(9.3*SIZE_FACTOR,9.0*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
			N.Draw();
			CircleShape S(CARROM,Position(3.0*SIZE_FACTOR,9.3*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
			S.Draw();
			CircleShape T(CARROM,Position(3.01*SIZE_FACTOR,9.3*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
			T.Draw();
			CircleShape U(CARROM,Position(9.0*SIZE_FACTOR,9.3*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
			U.Draw();
			CircleShape V(CARROM,Position(9.0*SIZE_FACTOR,9.3*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
			V.Draw();
			CARROM.RenderLine(Position(10.0*SIZE_FACTOR,10.0*SIZE_FACTOR),Position(8.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Black,0.0);
			CARROM.RenderLine(Position(8.0*SIZE_FACTOR,4.0*SIZE_FACTOR),Position(10.0*SIZE_FACTOR,2.0*SIZE_FACTOR),Black,0.0);
			Striker.Draw();
		}
		display_pieces();//displaying pieces
		CARROM.SetMouseClickCallback(CARROMMouseClick);
	}
	else if(x<12.0*SIZE_FACTOR && flag==1){//Setting the angle
		Position r=striker;//Getting position of Striker
		r.SetXDistance(r.GetXDistance()+0.34);//Setting position as the center of the striker
		r.SetYDistance(r.GetYDistance()+0.34);//Same
		striker_theta=calculate_theta(r,p);//calculating the slope/theta which is made by the line joining the center of the striker and the position of click
		end_point.SetXDistance(r.GetXDistance()+2.0*cos(striker_theta));
		end_point.SetYDistance(r.GetYDistance()+2.0*sin(striker_theta));
		//Restoring structure of CARROM and drawing the angle line
		if(turn%2==0){
			CARROM.RenderRectangle(Position(1.0*SIZE_FACTOR,1.0*SIZE_FACTOR),Position(11.0*SIZE_FACTOR,4.45*SIZE_FACTOR),White);
			CircleShape C(CARROM,Position(1.3*SIZE_FACTOR,1.3*SIZE_FACTOR),Black,0.6*SIZE_FACTOR);
			C.Draw();
			CircleShape E(CARROM,Position(10.7*SIZE_FACTOR,1.3*SIZE_FACTOR),Black,0.6*SIZE_FACTOR);
			E.Draw();
			CARROM.RenderLine(Position(2.5*SIZE_FACTOR,3.0*SIZE_FACTOR),Position(2.5*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.05);
			CARROM.RenderLine(Position(2.9*SIZE_FACTOR,3.0*SIZE_FACTOR),Position(2.9*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.0);
			CARROM.RenderLine(Position(9.5*SIZE_FACTOR,3.0*SIZE_FACTOR),Position(9.5*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.05);
			CARROM.RenderLine(Position(9.1*SIZE_FACTOR,3.0*SIZE_FACTOR),Position(9.1*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.0);
			CARROM.RenderLine(Position(3.0*SIZE_FACTOR,2.5*SIZE_FACTOR),Position(9.0*SIZE_FACTOR,2.5*SIZE_FACTOR),Black,0.05);
			CARROM.RenderLine(Position(3.0*SIZE_FACTOR,2.9*SIZE_FACTOR),Position(9.0*SIZE_FACTOR,2.9*SIZE_FACTOR),Black,0.0);
			CircleShape G(CARROM,Position(2.7*SIZE_FACTOR,3.0*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
			G.Draw();
			CircleShape H(CARROM,Position(2.7*SIZE_FACTOR,3.01*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
			H.Draw();
			CircleShape K(CARROM,Position(9.3*SIZE_FACTOR,3.0*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
			K.Draw();
			CircleShape L(CARROM,Position(9.3*SIZE_FACTOR,3.01*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
			L.Draw();
			CircleShape O(CARROM,Position(3.0*SIZE_FACTOR,2.7*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
			O.Draw();
			CircleShape P(CARROM,Position(3.01*SIZE_FACTOR,2.7*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
			P.Draw();
			CircleShape Q(CARROM,Position(9.0*SIZE_FACTOR,2.7*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
			Q.Draw();
			CircleShape R(CARROM,Position(9.0*SIZE_FACTOR,2.7*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
			R.Draw();
			CARROM.RenderLine(Position(2.0*SIZE_FACTOR,2.0*SIZE_FACTOR),Position(4.0*SIZE_FACTOR,4.0*SIZE_FACTOR),Black,0.0);
			CARROM.RenderLine(Position(8.0*SIZE_FACTOR,4.0*SIZE_FACTOR),Position(10.0*SIZE_FACTOR,2.0*SIZE_FACTOR),Black,0.0);
			CARROM.RenderLine(Position(4.0*SIZE_FACTOR,4.0*SIZE_FACTOR),Position(3.8*SIZE_FACTOR,3.6*SIZE_FACTOR),Black,0.0);
			CARROM.RenderLine(Position(4.0*SIZE_FACTOR,4.0*SIZE_FACTOR),Position(3.6*SIZE_FACTOR,3.8*SIZE_FACTOR),Black,0.0);
			CARROM.RenderLine(Position(8.0*SIZE_FACTOR,4.0*SIZE_FACTOR),Position(8.2*SIZE_FACTOR,3.6*SIZE_FACTOR),Black,0.0);
			CARROM.RenderLine(Position(8.0*SIZE_FACTOR,4.0*SIZE_FACTOR),Position(8.4*SIZE_FACTOR,3.8*SIZE_FACTOR),Black,0.0);
			Striker.SetPosition(striker);
			Striker.Draw();
		}
		else{
			CARROM.RenderRectangle(Position(1.0*SIZE_FACTOR,7.55*SIZE_FACTOR),Position(11.0*SIZE_FACTOR,11.0*SIZE_FACTOR),White);
			CircleShape D(CARROM,Position(1.3*SIZE_FACTOR,10.7*SIZE_FACTOR),Black,0.6*SIZE_FACTOR);
			D.Draw();
			CircleShape F(CARROM,Position(10.7*SIZE_FACTOR,10.7*SIZE_FACTOR),Black,0.6*SIZE_FACTOR);
			F.Draw();
			CARROM.RenderLine(Position(2.5*SIZE_FACTOR,3.0*SIZE_FACTOR),Position(2.5*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.05);
			CARROM.RenderLine(Position(2.9*SIZE_FACTOR,3.0*SIZE_FACTOR),Position(2.9*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.0);
			CARROM.RenderLine(Position(9.5*SIZE_FACTOR,3.0*SIZE_FACTOR),Position(9.5*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.05);
			CARROM.RenderLine(Position(9.1*SIZE_FACTOR,3.0*SIZE_FACTOR),Position(9.1*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.0);
			CARROM.RenderLine(Position(3.0*SIZE_FACTOR,9.5*SIZE_FACTOR),Position(9.0*SIZE_FACTOR,9.5*SIZE_FACTOR),Black,0.05);
			CARROM.RenderLine(Position(3.0*SIZE_FACTOR,9.1*SIZE_FACTOR),Position(9.0*SIZE_FACTOR,9.1*SIZE_FACTOR),Black,0.0);
			CircleShape I(CARROM,Position(2.7*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
			I.Draw();
			CircleShape J(CARROM,Position(2.7*SIZE_FACTOR,9.0*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
			J.Draw();
			CircleShape M(CARROM,Position(9.3*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
			M.Draw();
			CircleShape N(CARROM,Position(9.3*SIZE_FACTOR,9.0*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
			N.Draw();
			CircleShape S(CARROM,Position(3.0*SIZE_FACTOR,9.3*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
			S.Draw();
			CircleShape T(CARROM,Position(3.01*SIZE_FACTOR,9.3*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
			T.Draw();
			CircleShape U(CARROM,Position(9.0*SIZE_FACTOR,9.3*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
			U.Draw();
			CircleShape V(CARROM,Position(9.0*SIZE_FACTOR,9.3*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
			V.Draw();
			CARROM.RenderLine(Position(10.0*SIZE_FACTOR,10.0*SIZE_FACTOR),Position(8.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Black,0.0);
			CARROM.RenderLine(Position(2.0*SIZE_FACTOR,10.0*SIZE_FACTOR),Position(4.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Black,0.0);
			CARROM.RenderLine(Position(4.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Position(3.6*SIZE_FACTOR,8.2*SIZE_FACTOR),Black,0.0);
			CARROM.RenderLine(Position(4.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Position(3.8*SIZE_FACTOR,8.4*SIZE_FACTOR),Black,0.0);
			CARROM.RenderLine(Position(8.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Position(8.2*SIZE_FACTOR,8.4*SIZE_FACTOR),Black,0.0);
			CARROM.RenderLine(Position(8.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Position(8.4*SIZE_FACTOR,8.2*SIZE_FACTOR),Black,0.0);
			Striker.SetPosition(striker);
			Striker.Draw();
		}
		display_pieces();//Displaying pieces
		CARROM.RenderLine(r,end_point,Yellow,0.1);//Drawing the angle line
		CARROM.SetMouseClickCallback(CARROMMouseClick);
	}
	else if(x>13.0*SIZE_FACTOR && x<14.0*SIZE_FACTOR && y>3.0*SIZE_FACTOR && y<8.0*SIZE_FACTOR && flag==2){//Setting the power
		CARROM.RenderRectangle(Position(13.0*SIZE_FACTOR,3.0*SIZE_FACTOR),Position(14.0*SIZE_FACTOR,8.0*SIZE_FACTOR),White);
		CARROM.RenderRectangle(Position(13.0*SIZE_FACTOR,p.GetYDistance()),Position(14.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Red);//Displaying the power
		power=8.0*SIZE_FACTOR-p.GetYDistance();//Calculating the power
		CARROM.SetMouseClickCallback(CARROMMouseClick);
	}
	else if(x>12.0*SIZE_FACTOR && x<15.0*SIZE_FACTOR && y>11.0*SIZE_FACTOR && y<12.0*SIZE_FACTOR && flag==3){//Checking if click is on the SHOOT! button
		Shoot();//Initiating the shooting process
		turn++;//Changing turns
		Striker.Erase();
		flag=0;
		power=0.0;//Getting ready for the next shot
		CARROM.RenderRectangle(Position(13.0*SIZE_FACTOR,3.0*SIZE_FACTOR),Position(14.0*SIZE_FACTOR,8.0*SIZE_FACTOR),White);//Changing the button
		CARROM.RenderRectangle(Position(12.0*SIZE_FACTOR,11.0*SIZE_FACTOR),Position(15.0*SIZE_FACTOR,12.0*SIZE_FACTOR),Red);
		CARROM.RenderText(Position(13.0*SIZE_FACTOR,11.0*SIZE_FACTOR),Position(14.0*SIZE_FACTOR,12.0*SIZE_FACTOR),"POSITION SET",Yellow,Red);
		if(turn%2==0){
			Striker.SetPosition(Position(5.7*SIZE_FACTOR,2.4*SIZE_FACTOR));
			Striker.Draw();
			striker=Striker.GetPosition();
		}
		else{
			Striker.SetPosition(Position(5.7*SIZE_FACTOR,9.0*SIZE_FACTOR));
			Striker.Draw();
			striker=Striker.GetPosition();
		}
		if(balls_remaining!=0)CARROM.SetMouseClickCallback(CARROMMouseClick);
		else {
			cyan1_theta= cyan2_theta= cyan3_theta= cyan4_theta= blue1_theta= blue2_theta= blue3_theta= blue4_theta= black1_theta= black2_theta= black3_theta= black4_theta= green1_theta= green2_theta= green3_theta= green4_theta= 100.0;//Assigning the defaults again before next game
			turn=0;
			balls_remaining=16;
			foul=0;
			Open_Display_Score_Screen();//To open the screen to display the final score.
		}
	}
	else if(x>12.0*SIZE_FACTOR && x<15.0*SIZE_FACTOR && y>11.0*SIZE_FACTOR && y<12.0*SIZE_FACTOR && flag==0){//Checking if click is on POSITION SET button
		CARROM.RenderRectangle(Position(12.0*SIZE_FACTOR,11.0*SIZE_FACTOR),Position(15.0*SIZE_FACTOR,12.0*SIZE_FACTOR),Red);
		CARROM.RenderText(Position(13.0*SIZE_FACTOR,11.0*SIZE_FACTOR),Position(14.0*SIZE_FACTOR,12.0*SIZE_FACTOR),"ANGLE SET",Yellow,Red);
		flag++;
		if(turn%2==0){//Assigning default values of angle
			CARROM.RenderLine(Position(striker.GetXDistance()+0.34,striker.GetYDistance()+0.34),(end_point=Position(striker.GetXDistance()+0.34,4.0*SIZE_FACTOR)),Yellow,0.1);
			striker_theta=3.141592654/2;
		}
		else{
			CARROM.RenderLine(Position(striker.GetXDistance()+0.34,striker.GetYDistance()+0.34),(end_point=Position(striker.GetXDistance()+0.34,8.0*SIZE_FACTOR)),Yellow,0.1);
			striker_theta=-3.141592654/2;
		}
		CARROM.SetMouseClickCallback(CARROMMouseClick);
	}
	else if(x>12.0*SIZE_FACTOR && x<15.0*SIZE_FACTOR && y>11.0*SIZE_FACTOR && y<12.0*SIZE_FACTOR && flag==1){//Checking if click is on ANGLE SET button
		CARROM.RenderRectangle(Position(12.0*SIZE_FACTOR,11.0*SIZE_FACTOR),Position(15.0*SIZE_FACTOR,12.0*SIZE_FACTOR),Red);
		CARROM.RenderText(Position(13.0*SIZE_FACTOR,11.0*SIZE_FACTOR),Position(14.0*SIZE_FACTOR,12.0*SIZE_FACTOR),"POWER SET",Yellow,Red);
		flag++;
		CARROM.SetMouseClickCallback(CARROMMouseClick);
	}
	else if(x>12.0*SIZE_FACTOR && x<15.0*SIZE_FACTOR && y>11.0*SIZE_FACTOR && y<12.0*SIZE_FACTOR && flag==2){//Checking if click is on POWER SET button
		CARROM.RenderRectangle(Position(12.0*SIZE_FACTOR,11.0*SIZE_FACTOR),Position(15.0*SIZE_FACTOR,12.0*SIZE_FACTOR),Red);
		CARROM.RenderText(Position(13.0*SIZE_FACTOR,11.0*SIZE_FACTOR),Position(14.0*SIZE_FACTOR,12.0*SIZE_FACTOR),"SHOOT!",Yellow,Red);
		flag++;
		CARROM.SetMouseClickCallback(CARROMMouseClick);
	}
	else if(x>12.0*SIZE_FACTOR && x<15.0*SIZE_FACTOR && y>0.0*SIZE_FACTOR && y<1.0*SIZE_FACTOR){//Checking if click is on the EXIT button
		CARROM.Close();
		exit(0);
	}
	else//Otherwise, looking for another click
	CARROM.SetMouseClickCallback(CARROMMouseClick);
}

//Function to open the CARROM window initially
void Open_CARROM_screen(){
	CARROM.Open();
	assert(CARROM.GetStatus()==WindowOpen);
	//For the carrom frame
	CARROM.RenderRectangle(Position(0.0*SIZE_FACTOR,0.0*SIZE_FACTOR),Position(12.0*SIZE_FACTOR,12.0*SIZE_FACTOR),Black);
	CARROM.RenderRectangle(Position(1.0*SIZE_FACTOR,1.0*SIZE_FACTOR),Position(11.0*SIZE_FACTOR,11.0*SIZE_FACTOR),White);
	//For the power bar and players and instruction message
	CARROM.RenderRectangle(Position(12.0*SIZE_FACTOR,0.0*SIZE_FACTOR),Position(15.0*SIZE_FACTOR,12.0*SIZE_FACTOR),Yellow);
	CARROM.RenderRectangle(Position(13.0*SIZE_FACTOR,3.0*SIZE_FACTOR),Position(14.0*SIZE_FACTOR,8.0*SIZE_FACTOR),White);
	CARROM.RenderRectangle(Position(13.0*SIZE_FACTOR,(8.0-power)*SIZE_FACTOR),Position(14.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Red);
	CARROM.RenderText(Position(13.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Position(14.0*SIZE_FACTOR,9.0*SIZE_FACTOR),"Power Bar",Red,Yellow);
	CARROM.RenderRectangle(Position(13.0*SIZE_FACTOR,0.0*SIZE_FACTOR),Position(14.0*SIZE_FACTOR,1.0*SIZE_FACTOR),Black);
	CARROM.RenderText(Position(13.0*SIZE_FACTOR,0.0*SIZE_FACTOR),Position(14.0*SIZE_FACTOR,1.0*SIZE_FACTOR),"Exit",Cyan,Black);
	CARROM.RenderText(Position(12.0*SIZE_FACTOR,1.0*SIZE_FACTOR),Position(15.0*SIZE_FACTOR,2.0*SIZE_FACTOR),Player_1.give_name(),Blue,Yellow);
	CARROM.RenderText(Position(12.0*SIZE_FACTOR,9.0*SIZE_FACTOR),Position(15.0*SIZE_FACTOR,10.0*SIZE_FACTOR),Player_2.give_name(),Blue,Yellow);
	strcat(player_score,Player_1.give_score());
	CARROM.RenderText(Position(12.0*SIZE_FACTOR,2.0*SIZE_FACTOR),Position(15.0*SIZE_FACTOR,3.0*SIZE_FACTOR),player_score,Blue,Yellow);
	strcpy(player_score,"Score: ");
	strcat(player_score,Player_2.give_score());
	CARROM.RenderText(Position(12.0*SIZE_FACTOR,10.0*SIZE_FACTOR),Position(15.0*SIZE_FACTOR,11.0*SIZE_FACTOR),player_score,Blue,Yellow);
	strcpy(player_score,"Score: ");
	CARROM.RenderRectangle(Position(12.0*SIZE_FACTOR,11.0*SIZE_FACTOR),Position(15.0*SIZE_FACTOR,12.0*SIZE_FACTOR),Red);
	CARROM.RenderText(Position(13.0*SIZE_FACTOR,11.0*SIZE_FACTOR),Position(14.0*SIZE_FACTOR,12.0*SIZE_FACTOR),"POSITION SET",Yellow,Red);
	//For the corner pockets
	CircleShape C(CARROM,Position(1.3*SIZE_FACTOR,1.3*SIZE_FACTOR),Black,0.6*SIZE_FACTOR);
	C.Draw();
	CircleShape D(CARROM,Position(1.3*SIZE_FACTOR,10.7*SIZE_FACTOR),Black,0.6*SIZE_FACTOR);
	D.Draw();
	CircleShape E(CARROM,Position(10.7*SIZE_FACTOR,1.3*SIZE_FACTOR),Black,0.6*SIZE_FACTOR);
	E.Draw();
	CircleShape F(CARROM,Position(10.7*SIZE_FACTOR,10.7*SIZE_FACTOR),Black,0.6*SIZE_FACTOR);
	F.Draw();
	//For the side lines
	CARROM.RenderLine(Position(2.5*SIZE_FACTOR,3.0*SIZE_FACTOR),Position(2.5*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.05);
	CARROM.RenderLine(Position(2.9*SIZE_FACTOR,3.0*SIZE_FACTOR),Position(2.9*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(9.5*SIZE_FACTOR,3.0*SIZE_FACTOR),Position(9.5*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.05);
	CARROM.RenderLine(Position(9.1*SIZE_FACTOR,3.0*SIZE_FACTOR),Position(9.1*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(3.0*SIZE_FACTOR,2.5*SIZE_FACTOR),Position(9.0*SIZE_FACTOR,2.5*SIZE_FACTOR),Black,0.05);
	CARROM.RenderLine(Position(3.0*SIZE_FACTOR,2.9*SIZE_FACTOR),Position(9.0*SIZE_FACTOR,2.9*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(3.0*SIZE_FACTOR,9.5*SIZE_FACTOR),Position(9.0*SIZE_FACTOR,9.5*SIZE_FACTOR),Black,0.05);
	CARROM.RenderLine(Position(3.0*SIZE_FACTOR,9.1*SIZE_FACTOR),Position(9.0*SIZE_FACTOR,9.1*SIZE_FACTOR),Black,0.0);
	//For the smaller red circles
	CircleShape G(CARROM,Position(2.7*SIZE_FACTOR,3.0*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
	G.Draw();
	CircleShape H(CARROM,Position(2.7*SIZE_FACTOR,3.01*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
	H.Draw();
	CircleShape I(CARROM,Position(2.7*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
	I.Draw();
	CircleShape J(CARROM,Position(2.7*SIZE_FACTOR,9.0*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
	J.Draw();
	CircleShape K(CARROM,Position(9.3*SIZE_FACTOR,3.0*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
	K.Draw();
	CircleShape L(CARROM,Position(9.3*SIZE_FACTOR,3.01*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
	L.Draw();
	CircleShape M(CARROM,Position(9.3*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
	M.Draw();
	CircleShape N(CARROM,Position(9.3*SIZE_FACTOR,9.0*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
	N.Draw();
	CircleShape O(CARROM,Position(3.0*SIZE_FACTOR,2.7*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
	O.Draw();
	CircleShape P(CARROM,Position(3.01*SIZE_FACTOR,2.7*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
	P.Draw();
	CircleShape Q(CARROM,Position(9.0*SIZE_FACTOR,2.7*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
	Q.Draw();
	CircleShape R(CARROM,Position(9.0*SIZE_FACTOR,2.7*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
	R.Draw();
	CircleShape S(CARROM,Position(3.0*SIZE_FACTOR,9.3*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
	S.Draw();
	CircleShape T(CARROM,Position(3.01*SIZE_FACTOR,9.3*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
	T.Draw();
	CircleShape U(CARROM,Position(9.0*SIZE_FACTOR,9.3*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
	U.Draw();
	CircleShape V(CARROM,Position(9.0*SIZE_FACTOR,9.3*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
	V.Draw();
	//For the lines between the red circles
	CARROM.RenderLine(Position(2.0*SIZE_FACTOR,2.0*SIZE_FACTOR),Position(4.0*SIZE_FACTOR,4.0*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(2.0*SIZE_FACTOR,10.0*SIZE_FACTOR),Position(4.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(10.0*SIZE_FACTOR,10.0*SIZE_FACTOR),Position(8.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(8.0*SIZE_FACTOR,4.0*SIZE_FACTOR),Position(10.0*SIZE_FACTOR,2.0*SIZE_FACTOR),Black,0.0);
	//For the centeral circle
	CircleShape m(CARROM,Position(6.0*SIZE_FACTOR,6.0*SIZE_FACTOR),White,3.0*SIZE_FACTOR);
	m.Draw();
	CircleShape n(CARROM,Position(6.0*SIZE_FACTOR,6.0*SIZE_FACTOR),Black,0.44*SIZE_FACTOR);
	n.Draw();
	CircleShape l(CARROM,Position(6.0*SIZE_FACTOR,6.0*SIZE_FACTOR),Red,0.4*SIZE_FACTOR);
	l.Draw();
	//For the arrow at the end of lines between small red circles
	CARROM.RenderLine(Position(4.0*SIZE_FACTOR,4.0*SIZE_FACTOR),Position(3.8*SIZE_FACTOR,3.6*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(4.0*SIZE_FACTOR,4.0*SIZE_FACTOR),Position(3.6*SIZE_FACTOR,3.8*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(8.0*SIZE_FACTOR,4.0*SIZE_FACTOR),Position(8.2*SIZE_FACTOR,3.6*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(8.0*SIZE_FACTOR,4.0*SIZE_FACTOR),Position(8.4*SIZE_FACTOR,3.8*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(4.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Position(3.6*SIZE_FACTOR,8.2*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(4.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Position(3.8*SIZE_FACTOR,8.4*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(8.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Position(8.2*SIZE_FACTOR,8.4*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(8.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Position(8.4*SIZE_FACTOR,8.2*SIZE_FACTOR),Black,0.0);		
	//For striker and pieces
	Striker.Load("Striker.xpm");
	Striker.SetPosition(Position(5.7*SIZE_FACTOR,2.4*SIZE_FACTOR));
	Striker.Draw();
	striker=Striker.GetPosition();
	Cyan1.Load("Cyan.xpm");
	Cyan1.SetPosition(Position(4.7*SIZE_FACTOR,4.7*SIZE_FACTOR));
	Cyan1.Draw();
	cyan1=Cyan1.GetPosition();
	Cyan2.Load("Cyan.xpm");
	Cyan2.SetPosition(Position(5.45*SIZE_FACTOR,5.45*SIZE_FACTOR));
	Cyan2.Draw();
	cyan2=Cyan2.GetPosition();
	Cyan3.Load("Cyan.xpm");
	Cyan3.SetPosition(Position(6.95*SIZE_FACTOR,6.95*SIZE_FACTOR));
	Cyan3.Draw();
	cyan3=Cyan3.GetPosition();
	Cyan4.Load("Cyan.xpm");
	Cyan4.SetPosition(Position(6.2*SIZE_FACTOR,6.2*SIZE_FACTOR));
	Cyan4.Draw();
	cyan4=Cyan4.GetPosition();
	Green1.Load("Green.xpm");
	Green1.SetPosition(Position(4.7*SIZE_FACTOR,6.2*SIZE_FACTOR));
	Green1.Draw();
	green1=Green1.GetPosition();
	Green2.Load("Green.xpm");
	Green2.SetPosition(Position(5.45*SIZE_FACTOR,6.95*SIZE_FACTOR));
	Green2.Draw();
	green2=Green2.GetPosition();
	Green3.Load("Green.xpm");
	Green3.SetPosition(Position(6.2*SIZE_FACTOR,4.7*SIZE_FACTOR));
	Green3.Draw();
	green3=Green3.GetPosition();
	Green4.Load("Green.xpm");
	Green4.SetPosition(Position(6.95*SIZE_FACTOR,5.45*SIZE_FACTOR));
	Green4.Draw();
	green4=Green4.GetPosition();
	Blue1.Load("Blue.xpm");
	Blue1.SetPosition(Position(4.7*SIZE_FACTOR,5.45*SIZE_FACTOR));
	Blue1.Draw();
	blue1=Blue1.GetPosition();
	Blue2.Load("Blue.xpm");
	Blue2.SetPosition(Position(5.45*SIZE_FACTOR,6.2*SIZE_FACTOR));
	Blue2.Draw();
	blue2=Blue2.GetPosition();
	Blue3.Load("Blue.xpm");
	Blue3.SetPosition(Position(6.2*SIZE_FACTOR,6.95*SIZE_FACTOR));
	Blue3.Draw();
	blue3=Blue3.GetPosition();
	Blue4.Load("Blue.xpm");
	Blue4.SetPosition(Position(6.95*SIZE_FACTOR,4.7*SIZE_FACTOR));
	Blue4.Draw();
	blue4=Blue4.GetPosition();
	Black1.Load("Black.xpm");
	Black1.SetPosition(Position(4.7*SIZE_FACTOR,6.95*SIZE_FACTOR));
	Black1.Draw();
	black1=Black1.GetPosition();
	Black2.Load("Black.xpm");
	Black2.SetPosition(Position(5.45*SIZE_FACTOR,4.7*SIZE_FACTOR));
	Black2.Draw();
	black2=Black2.GetPosition();
	Black3.Load("Black.xpm");
	Black3.SetPosition(Position(6.2*SIZE_FACTOR,5.45*SIZE_FACTOR));
	Black3.Draw();
	black3=Black3.GetPosition();
	Black4.Load("Black.xpm");
	Black4.SetPosition(Position(6.95*SIZE_FACTOR,6.2*SIZE_FACTOR));
	Black4.Draw();
	black4=Black4.GetPosition();
	CARROM.SetMouseClickCallback(CARROMMouseClick);
}

//Function to calculate the slope of the line joining the two given points
float calculate_theta(Position X,Position Y){
	Y.SetXDistance(Y.GetXDistance()-X.GetXDistance());//Shifting the origin
	Y.SetYDistance(Y.GetYDistance()-X.GetYDistance());
	float theta=atan2(Y.GetYDistance(),Y.GetXDistance());//Calculating the theta by slope method
	return theta;
}

//Function to show the repaired background of the carrom
void repair_carrom_background(){
	//For the carrom frame
	CARROM.RenderRectangle(Position(0.0*SIZE_FACTOR,0.0*SIZE_FACTOR),Position(12.0*SIZE_FACTOR,12.0*SIZE_FACTOR),Black);
	CARROM.RenderRectangle(Position(1.0*SIZE_FACTOR,1.0*SIZE_FACTOR),Position(11.0*SIZE_FACTOR,11.0*SIZE_FACTOR),White);
	//For the score
	strcat(player_score,Player_1.give_score());
	CARROM.RenderRectangle(Position(12.0*SIZE_FACTOR,2.0*SIZE_FACTOR),Position(15.0*SIZE_FACTOR,3.0*SIZE_FACTOR),Yellow);
	CARROM.RenderText(Position(12.0*SIZE_FACTOR,2.0*SIZE_FACTOR),Position(15.0*SIZE_FACTOR,3.0*SIZE_FACTOR),player_score,Blue,Yellow);
	strcpy(player_score,"Score: ");
	strcat(player_score,Player_2.give_score());
	CARROM.RenderRectangle(Position(12.0*SIZE_FACTOR,10.0*SIZE_FACTOR),Position(15.0*SIZE_FACTOR,11.0*SIZE_FACTOR),Yellow);
	CARROM.RenderText(Position(12.0*SIZE_FACTOR,10.0*SIZE_FACTOR),Position(15.0*SIZE_FACTOR,11.0*SIZE_FACTOR),player_score,Blue,Yellow);
	strcpy(player_score,"Score: ");
	//For the side lines
	CARROM.RenderLine(Position(2.5*SIZE_FACTOR,3.0*SIZE_FACTOR),Position(2.5*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.05);
	CARROM.RenderLine(Position(2.9*SIZE_FACTOR,3.0*SIZE_FACTOR),Position(2.9*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(9.5*SIZE_FACTOR,3.0*SIZE_FACTOR),Position(9.5*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.05);
	CARROM.RenderLine(Position(9.1*SIZE_FACTOR,3.0*SIZE_FACTOR),Position(9.1*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(3.0*SIZE_FACTOR,2.5*SIZE_FACTOR),Position(9.0*SIZE_FACTOR,2.5*SIZE_FACTOR),Black,0.05);
	CARROM.RenderLine(Position(3.0*SIZE_FACTOR,2.9*SIZE_FACTOR),Position(9.0*SIZE_FACTOR,2.9*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(3.0*SIZE_FACTOR,9.5*SIZE_FACTOR),Position(9.0*SIZE_FACTOR,9.5*SIZE_FACTOR),Black,0.05);
	CARROM.RenderLine(Position(3.0*SIZE_FACTOR,9.1*SIZE_FACTOR),Position(9.0*SIZE_FACTOR,9.1*SIZE_FACTOR),Black,0.0);
	//For the smaller red circles
	CircleShape G(CARROM,Position(2.7*SIZE_FACTOR,3.0*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
	G.Draw();
	CircleShape H(CARROM,Position(2.7*SIZE_FACTOR,3.01*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
	H.Draw();
	CircleShape I(CARROM,Position(2.7*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
	I.Draw();
	CircleShape J(CARROM,Position(2.7*SIZE_FACTOR,9.0*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
	J.Draw();
	CircleShape K(CARROM,Position(9.3*SIZE_FACTOR,3.0*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
	K.Draw();
	CircleShape L(CARROM,Position(9.3*SIZE_FACTOR,3.01*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
	L.Draw();
	CircleShape M(CARROM,Position(9.3*SIZE_FACTOR,9.0*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
	M.Draw();
	CircleShape N(CARROM,Position(9.3*SIZE_FACTOR,9.0*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
	N.Draw();
	CircleShape O(CARROM,Position(3.0*SIZE_FACTOR,2.7*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
	O.Draw();
	CircleShape P(CARROM,Position(3.01*SIZE_FACTOR,2.7*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
	P.Draw();
	CircleShape Q(CARROM,Position(9.0*SIZE_FACTOR,2.7*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
	Q.Draw();
	CircleShape R(CARROM,Position(9.0*SIZE_FACTOR,2.7*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
	R.Draw();
	CircleShape S(CARROM,Position(3.0*SIZE_FACTOR,9.3*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
	S.Draw();
	CircleShape T(CARROM,Position(3.01*SIZE_FACTOR,9.3*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
	T.Draw();
	CircleShape U(CARROM,Position(9.0*SIZE_FACTOR,9.3*SIZE_FACTOR),Black,0.4*SIZE_FACTOR);
	U.Draw();
	CircleShape V(CARROM,Position(9.0*SIZE_FACTOR,9.3*SIZE_FACTOR),Red,0.35*SIZE_FACTOR);
	V.Draw();
	//For the lines between the red circles
	CARROM.RenderLine(Position(2.0*SIZE_FACTOR,2.0*SIZE_FACTOR),Position(4.0*SIZE_FACTOR,4.0*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(2.0*SIZE_FACTOR,10.0*SIZE_FACTOR),Position(4.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(10.0*SIZE_FACTOR,10.0*SIZE_FACTOR),Position(8.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(8.0*SIZE_FACTOR,4.0*SIZE_FACTOR),Position(10.0*SIZE_FACTOR,2.0*SIZE_FACTOR),Black,0.0);
	//For the centeral circle
	CircleShape m(CARROM,Position(6.0*SIZE_FACTOR,6.0*SIZE_FACTOR),White,3.0*SIZE_FACTOR);
	m.Draw();
	CircleShape n(CARROM,Position(6.0*SIZE_FACTOR,6.0*SIZE_FACTOR),Black,0.44*SIZE_FACTOR);
	n.Draw();
	CircleShape l(CARROM,Position(6.0*SIZE_FACTOR,6.0*SIZE_FACTOR),Red,0.4*SIZE_FACTOR);
	l.Draw();
	//For the arrow at the end of lines between small red circles
	CARROM.RenderLine(Position(4.0*SIZE_FACTOR,4.0*SIZE_FACTOR),Position(3.8*SIZE_FACTOR,3.6*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(4.0*SIZE_FACTOR,4.0*SIZE_FACTOR),Position(3.6*SIZE_FACTOR,3.8*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(8.0*SIZE_FACTOR,4.0*SIZE_FACTOR),Position(8.2*SIZE_FACTOR,3.6*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(8.0*SIZE_FACTOR,4.0*SIZE_FACTOR),Position(8.4*SIZE_FACTOR,3.8*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(4.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Position(3.6*SIZE_FACTOR,8.2*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(4.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Position(3.8*SIZE_FACTOR,8.4*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(8.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Position(8.2*SIZE_FACTOR,8.4*SIZE_FACTOR),Black,0.0);
	CARROM.RenderLine(Position(8.0*SIZE_FACTOR,8.0*SIZE_FACTOR),Position(8.4*SIZE_FACTOR,8.2*SIZE_FACTOR),Black,0.0);
	//For the corner pockets
	CircleShape C(CARROM,Position(1.3*SIZE_FACTOR,1.3*SIZE_FACTOR),Black,0.6*SIZE_FACTOR);
	C.Draw();
	CircleShape D(CARROM,Position(1.3*SIZE_FACTOR,10.7*SIZE_FACTOR),Black,0.6*SIZE_FACTOR);
	D.Draw();
	CircleShape E(CARROM,Position(10.7*SIZE_FACTOR,1.3*SIZE_FACTOR),Black,0.6*SIZE_FACTOR);
	E.Draw();
	CircleShape F(CARROM,Position(10.7*SIZE_FACTOR,10.7*SIZE_FACTOR),Black,0.6*SIZE_FACTOR);
	F.Draw();
	return;
}

//Function to display the pieces
void display_pieces(){//Checking if the pieces are not at rest and also not already potted
	if(cyan1.GetXDistance()!=-100.0 && cyan1_theta!=101.0) Cyan1.Draw();
	if(cyan2.GetXDistance()!=-100.0 && cyan2_theta!=101.0) Cyan2.Draw();
	if(cyan3.GetXDistance()!=-100.0 && cyan3_theta!=101.0) Cyan3.Draw();
	if(cyan4.GetXDistance()!=-100.0 && cyan4_theta!=101.0) Cyan4.Draw();
	if(blue1.GetXDistance()!=-100.0 && blue1_theta!=101.0) Blue1.Draw();
	if(blue2.GetXDistance()!=-100.0 && blue2_theta!=101.0) Blue2.Draw();
	if(blue3.GetXDistance()!=-100.0 && blue3_theta!=101.0) Blue3.Draw();
	if(blue4.GetXDistance()!=-100.0 && blue4_theta!=101.0) Blue4.Draw();
	if(black1.GetXDistance()!=-100.0 && black1_theta!=101.0) Black1.Draw();
	if(black2.GetXDistance()!=-100.0 && black2_theta!=101.0) Black2.Draw();
	if(black3.GetXDistance()!=-100.0 && black3_theta!=101.0) Black3.Draw();
	if(black4.GetXDistance()!=-100.0 && black4_theta!=101.0) Black4.Draw();
	if(green1.GetXDistance()!=-100.0 && green1_theta!=101.0) Green1.Draw();
	if(green2.GetXDistance()!=-100.0 && green2_theta!=101.0) Green2.Draw();
	if(green3.GetXDistance()!=-100.0 && green3_theta!=101.0) Green3.Draw();
	if(green4.GetXDistance()!=-100.0 && green4_theta!=101.0) Green4.Draw();
	return;
}
#endif
